Imports System.Data.SqlClient
Public Class Form1
    Inherits System.Windows.Forms.Form
    Const SQL_CONNECTION = "Data Source=localhost;Initial Catalog=Northwind;" & _
        "User ID=sa;"
    Const SQL_COUNTRIES = "SELECT DISTINCT Suppliers.Country FROM Suppliers"
    Const SQL_PRODUCTS = "SELECT * FROM Products"
    Const SQL_SUPPLIERS = "SELECT * FROM Suppliers"

    Private Sub FillComboBoxFromDataSet()

        ' Purpose:  Populate the combo box with countries list, from a DataSet

        Dim dsCountries As DataSet        ' Form-level DataSet object

        ' Load list of countries into the combo box, from the DataSet
        dsCountries = ListCountriesInDataSet()

        ' Bind the combo box, cboCountries, to the DataSet
        cboCountries.DataSource = dsCountries.Tables("Countries")
        cboCountries.DisplayMember = "Country"

    End Sub

    Private Sub FillComboBoxFromDataReader()
        Dim cnn As New SqlConnection _
  ("Data Source=localhost;Initial Catalog=Northwind;User ID=sa;")
        Dim cmd As New SqlCommand _
  ("SELECT DISTINCT Suppliers.Country FROM Suppliers", cnn)
        Dim dr As SqlDataReader

        ' open the connection
        cnn.Open()
        ' execute the command to return a DataReader
        dr = cmd.ExecuteReader()

        ' while there are still values in the data reader, add them to the list
        While dr.Read()
            ' we read a string because we know to expect a string and 
            ' not another value type
            cboCountries.Items.Add(dr.GetString(0))
        End While
        cnn.Close()

    End Sub

    Public Function ListCountriesInDataSet() As System.Data.DataSet

        ' Purpose:  Return the Supplier Countries, in a DataSet

        Dim sqlConn As SqlConnection
        Dim sqlCmd As SqlCommand
        Dim sqlAdapt As SqlDataAdapter

        ' New Dataset, named "ListOfCountries"
        Dim rowDataSet As New DataSet("ListOfCountries")

        Try
            ' Create a new connection object
            sqlConn = New SqlConnection(SQL_CONNECTION)

            ' Create a new command object
            sqlCmd = New SqlCommand(SQL_COUNTRIES, sqlConn)

            ' Open the connection
            sqlConn.Open()

            ' Open a DataAdapter object, using the command object
            sqlAdapt = New SqlDataAdapter(sqlCmd)

            ' Execute the command and retrieve the records in the DataSet
            ' The DataTable is named "Countries"
            sqlAdapt.Fill(rowDataSet, "Countries")

        Catch e As SqlException
            MsgBox("Error " & e.Number & ": " & e.Message & " [" & _
               e.Source & "]")
        Finally
            sqlConn.Close() ' The connection is not needed anymore
        End Try

        Return (rowDataSet)

    End Function

    Public Function ListSuppliersAndProducts() As DataSet

        ' Purpose:  Return list of Suppliers AND Products
        ' in a DataSet object, with multiple resultsets

        Dim sqlConn As SqlConnection
        Dim sqlCmdSuppliers As SqlCommand
        Dim sqlCmdProducts As SqlCommand
        Dim sqlAdaptSuppliers As SqlDataAdapter
        Dim sqlAdaptProducts As SqlDataAdapter
        Dim rowDataSet As New DataSet()

        Try
            ' Create a new connection object
            sqlConn = New SqlConnection(SQL_CONNECTION)

            ' Assign one command object per table
            sqlCmdProducts = New SqlCommand(SQL_PRODUCTS, sqlConn)
            sqlCmdSuppliers = New SqlCommand(SQL_SUPPLIERS, sqlConn)

            ' Open the connection
            sqlConn.Open()

            ' Open DataAdapter objects, using the command objects
            sqlAdaptSuppliers = New SqlDataAdapter(sqlCmdSuppliers)
            sqlAdaptProducts = New SqlDataAdapter(sqlCmdProducts)

            ' Populate the DataSet from the DataAdapters
            sqlAdaptSuppliers.Fill(rowDataSet, "Suppliers")
            sqlAdaptProducts.Fill(rowDataSet, "Products")

            ' Define a DataRelation between Suppliers and Products, on SupplierID
            Dim relSuppliersToProducts As New DataRelation( _
              "SuppliersToProducts", _
              rowDataSet.Tables("Suppliers").Columns("SupplierID"), _
              rowDataSet.Tables("Products").Columns("SupplierID"))

            rowDataSet.Relations.Add(relSuppliersToProducts)

        Catch e As SqlException
            MsgBox("Error " & e.Number & ": " & e.Message & " [" & e.Source & "]")
        Finally
            sqlConn.Close()
        End Try

        Return (rowDataSet)

    End Function


#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents cboCountries As System.Windows.Forms.ComboBox
    Friend WithEvents Button1 As System.Windows.Forms.Button

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.cboCountries = New System.Windows.Forms.ComboBox()
        Me.btnDataView = New System.Windows.Forms.Button()
        Me.Button1 = New System.Windows.Forms.Button()
        Me.Button2 = New System.Windows.Forms.Button()
        Me.DataGrid1 = New System.Windows.Forms.DataGrid()
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'cboCountries
        '
        Me.cboCountries.DropDownWidth = 256
        Me.cboCountries.Location = New System.Drawing.Point(8, 8)
        Me.cboCountries.Name = "cboCountries"
        Me.cboCountries.Size = New System.Drawing.Size(256, 21)
        Me.cboCountries.TabIndex = 0
        '
        'btnDataView
        '
        Me.btnDataView.Location = New System.Drawing.Point(456, 376)
        Me.btnDataView.Name = "btnDataView"
        Me.btnDataView.Size = New System.Drawing.Size(120, 24)
        Me.btnDataView.TabIndex = 4
        Me.btnDataView.Text = "Load Filtered Data"
        '
        'Button1
        '
        Me.Button1.Location = New System.Drawing.Point(8, 32)
        Me.Button1.Name = "Button1"
        Me.Button1.Size = New System.Drawing.Size(96, 24)
        Me.Button1.TabIndex = 1
        Me.Button1.Text = "Load Countries"
        '
        'Button2
        '
        Me.Button2.Location = New System.Drawing.Point(8, 376)
        Me.Button2.Name = "Button2"
        Me.Button2.Size = New System.Drawing.Size(120, 24)
        Me.Button2.TabIndex = 3
        Me.Button2.Text = "Load Related Data"
        '
        'DataGrid1
        '
        Me.DataGrid1.DataMember = ""
        Me.DataGrid1.Location = New System.Drawing.Point(8, 64)
        Me.DataGrid1.Name = "DataGrid1"
        Me.DataGrid1.Size = New System.Drawing.Size(568, 312)
        Me.DataGrid1.TabIndex = 2
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(584, 405)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.btnDataView, Me.Button2, Me.DataGrid1, Me.Button1, Me.cboCountries})
        Me.Name = "Form1"
        Me.Text = "Demo"
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        FillComboBoxFromDataReader()

        ' It's also possible to fill the combo box from a dataset, using the procedure call below:
        'FillComboBoxFromDataSet()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        DataGrid1.DataSource = ListSuppliersAndProducts()
    End Sub
    Friend WithEvents Button2 As System.Windows.Forms.Button
    Friend WithEvents DataGrid1 As System.Windows.Forms.DataGrid

    Private Sub btnDataView_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDataView.Click
        ' Purpose: Populate the DataGrid with Suppliers using a DataView 
        ' by (selected) Country

        Dim dsSuppliers As DataSet
        Dim dsDataView As DataView
        Dim strCountry As String

        ' Use the combobox created in the "retrieving a dataset" example
        strCountry = cboCountries.Text.ToString

        ' Use the function given above that returns all Suppliers, Products
        ' and their relationship
        dsSuppliers = ListSuppliersAndProducts()

        ' Construct a DataView, filtered by the selected country
        dsDataView = New DataView(dsSuppliers.Tables("Suppliers"))
        dsDataView.RowFilter = "Country Like '" & strCountry & "*'"

        ' Sort DataView, by Supplier CompanyName ASC
        ' Note, this will add a sort arrow to the datagrid for this field
        dsDataView.Sort = "CompanyName ASC"

        ' Populate DataGrid with the DataView
        DataGrid1.DataSource = dsDataView

    End Sub
    Friend WithEvents btnDataView As System.Windows.Forms.Button

End Class
