using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;						// Sql Connection support
using System.Threading;								// Thread support


namespace csAsync
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button m_btnOpen;
		private System.Windows.Forms.Button m_btnClose;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.m_btnOpen = new System.Windows.Forms.Button();
			this.m_btnClose = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// m_btnOpen
			// 
			this.m_btnOpen.Location = new System.Drawing.Point(16, 8);
			this.m_btnOpen.Name = "m_btnOpen";
			this.m_btnOpen.TabIndex = 0;
			this.m_btnOpen.Text = "Open";
			this.m_btnOpen.Click += new System.EventHandler(this.m_btnOpen_Click);
			// 
			// m_btnClose
			// 
			this.m_btnClose.Enabled = false;
			this.m_btnClose.Location = new System.Drawing.Point(104, 8);
			this.m_btnClose.Name = "m_btnClose";
			this.m_btnClose.TabIndex = 1;
			this.m_btnClose.Text = "Close";
			this.m_btnClose.Click += new System.EventHandler(this.m_btnClose_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(200, 45);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.m_btnClose,
																		  this.m_btnOpen});
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		} 

		// Event delegate and Connection object definition
		SqlConnection m_sqlConn = new SqlConnection();
		delegate void NotifyConnectionEventHandler( string sMessage );
		private NotifyConnectionEventHandler m_NotifyParent = null;

		// Open pressed so start connection attempt. 
		private void m_btnOpen_Click(object sender, System.EventArgs e)
		{
			// Here we call open an another thread freeing the UI.
			m_NotifyParent = new NotifyConnectionEventHandler( OnNotifyConnection );
			Thread connectThread = new Thread( new ThreadStart( OnThreadStart ) );
			connectThread.Start();
			// Here we call open in the UI thread so the UI is blocked
			//OnThreadStart();
			m_btnOpen.Enabled = false;
		}

		// Close the connection
		private void m_btnClose_Click(object sender, System.EventArgs e)
		{
			// Safely call close (Not really necessary)
			lock( m_sqlConn )
			{
				m_sqlConn.Close();
			}
			m_btnOpen.Enabled = true;
			m_btnClose.Enabled = false;
		}

		// Notifications form thread arrive here
		private void OnNotifyConnection( string sMessage )
		{
			MessageBox.Show( sMessage, "OnNotifyConnection" );
			switch( m_sqlConn.State )
			{
				case ConnectionState.Open :
					m_btnClose.Enabled = true;
					break;
				case ConnectionState.Closed :
					m_btnOpen.Enabled = true;
					break;
				default:
					MessageBox.Show( "ERROR: Unexpected connection state!" );
					break;
			}
		}

		// This may be executed in the IU thread or by another thread
		public void OnThreadStart()
		{
			string sResult;
			try
			{
				// Setup connection and open safely
				lock( m_sqlConn )
				{
					m_sqlConn.ConnectionString ="data source=localhost;"+
						"initial catalog=Northwind;"+
						"integrated security=SSPI;";
					m_sqlConn.Open();
				}
				sResult = "Connected";
			}
			catch( Exception ex )
			{
				sResult = ex.Message;
			}
			// Return result
			if( InvokeRequired )
				BeginInvoke( m_NotifyParent, new string[]{ sResult }  );
			else
				m_NotifyParent( sResult );
		}
	}


}
