Imports System.Data.SqlClient
Imports System.Threading

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents m_btnOpen As System.Windows.Forms.Button
    Friend WithEvents m_btnClose As System.Windows.Forms.Button

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.m_btnOpen = New System.Windows.Forms.Button()
        Me.m_btnClose = New System.Windows.Forms.Button()
        Me.SuspendLayout()
        '
        'm_btnOpen
        '
        Me.m_btnOpen.Location = New System.Drawing.Point(24, 16)
        Me.m_btnOpen.Name = "m_btnOpen"
        Me.m_btnOpen.TabIndex = 0
        Me.m_btnOpen.Text = "Open"
        '
        'm_btnClose
        '
        Me.m_btnClose.Enabled = False
        Me.m_btnClose.Location = New System.Drawing.Point(112, 16)
        Me.m_btnClose.Name = "m_btnClose"
        Me.m_btnClose.TabIndex = 1
        Me.m_btnClose.Text = "Close"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(224, 53)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.m_btnClose, Me.m_btnOpen})
        Me.Name = "Form1"
        Me.Text = "Acynchronous Connection"
        Me.ResumeLayout(False)

    End Sub

#End Region

	' Event delegate and Connection object definition
	Dim m_sqlConn As SqlConnection = New SqlConnection()
	Delegate Sub NotifyConnectionEventHandler(ByVal sMessage As String)
	Dim m_NotifyParent As NotifyConnectionEventHandler = Nothing

	Private Sub m_btnOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles m_btnOpen.Click
		' Here we call open an another thread freeing the UI.
		m_NotifyParent = New NotifyConnectionEventHandler(AddressOf OnNotifyConnection)
		Dim connectThread As Thread = New Thread(New ThreadStart(AddressOf OnThreadStart))
		connectThread.Start()
		' Here we call open in the UI thread so the UI is blocked
		' OnThreadStart()
		m_btnOpen.Enabled = False
	End Sub

	Private Sub m_btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles m_btnClose.Click
		' Safely call close (Not really necessary)
		SyncLock m_sqlConn
			m_sqlConn.Close()
		End SyncLock
		m_btnOpen.Enabled = True
		m_btnClose.Enabled = False
	End Sub

	' Notifications form thread arrive here
	Private Sub OnNotifyConnection(ByVal sMessage As String)
		MessageBox.Show(sMessage, "OnNotifyConnection")
		If (m_sqlConn.State = ConnectionState.Open) Then
			m_btnClose.Enabled = True
			Return
		End If

		If (m_sqlConn.State = ConnectionState.Closed) Then
			m_btnOpen.Enabled = True
			Return
		End If
		MessageBox.Show("ERROR: Unexpected connection state!")
	End Sub

	' This may be executed in the IU thread or by another thread
	Public Sub OnThreadStart()
		Dim sResult As String
		Try
			' Setup connection and open safely
			SyncLock m_sqlConn
                m_sqlConn.ConnectionString = "data source=localhost;" & _
                 "initial catalog=Northwind;" & _
                 "integrated security=SSPI;"
				m_sqlConn.Open()
			End SyncLock
			sResult = "Connected"
		Catch ex As Exception
			sResult = ex.Message
		End Try
		' Return result
		If (InvokeRequired) Then
			BeginInvoke(m_NotifyParent, New String() {sResult})
		Else
			m_NotifyParent(sResult)
		End If
	End Sub


End Class

