using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;

namespace Example1
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		static void Main(string[] args)
		{
			// Create a table
			DataTable dt = new DataTable("tabAuthors");
		
			// Create the ID column, no null allowed and must be unique
			DataColumn dcID = new DataColumn("AuthorID", typeof(Int32));
			dcID.Unique = true;
			dcID.AllowDBNull = false;
			dt.Columns.Add(dcID);

			// Create the FirstName column, no null allowed
			DataColumn dcAuthorFirstName = new DataColumn("Author_FirstName",typeof(String));
			dcAuthorFirstName.MaxLength = 50;
			dcAuthorFirstName.AllowDBNull = false;
			dt.Columns.Add(dcAuthorFirstName);

			// Create the LastName column, no null allowed
			DataColumn dcAuthorLastName = new DataColumn("Author_LastName",typeof(String));
			dcAuthorLastName.MaxLength = 50;
			dcAuthorLastName.AllowDBNull = false;
			dt.Columns.Add(dcAuthorLastName);

			// Add the table to the DataSet
			DataSet dsWrox = new DataSet("WroxAuthors");
			dsWrox.Tables.Add(dt);

			// Add a couple of rows
			DataRow r = dsWrox.Tables[0].NewRow();
			r["AuthorID"] = 1;
			r["Author_FirstName"] = "Fabio Claudio";
			r["Author_LastName"] = "Ferracchiati";
			dsWrox.Tables[0].Rows.Add(r);

			r = dsWrox.Tables[0].NewRow();
			r["AuthorID"] = 2;
			r["Author_FirstName"] = "Alex";
			r["Author_LastName"] = "Homer";
			dsWrox.Tables[0].Rows.Add(r);

			// Add another table
			DataTable dtPayment = new DataTable("tabPayments");

			// Create the ID column, no null allowed and must be unique
			DataColumn dcIDFK = new DataColumn("AuthorID", typeof(Int32));
			dcIDFK.Unique = true;
			dcIDFK.AllowDBNull = false;
			dtPayment.Columns.Add(dcIDFK);

			// Create the PaymentID column, no null allowed and must be unique
			DataColumn dcPaymentID = new DataColumn("PaymentID", typeof(Int32));
			dcPaymentID.Unique = true;
			dcPaymentID.AllowDBNull = false;
			dcPaymentID.AutoIncrement = true;
			dcPaymentID.AutoIncrementSeed = 1;
			dcPaymentID.AutoIncrementStep = 1;
			dtPayment.Columns.Add(dcPaymentID);

			// Create the PaymentID column, no null allowed and must be unique
			DataColumn dcPayment = new DataColumn("Payment", typeof(SqlMoney));
			dcPayment.AllowDBNull = false;
			dtPayment.Columns.Add(dcPayment);

			dsWrox.Tables.Add(dtPayment);

			// Add a couple of rows
			r = dsWrox.Tables["tabPayments"].NewRow();
			r["AuthorID"] = 1;
			r["Payment"] = 20;
			dsWrox.Tables["tabPayments"].Rows.Add(r);

			r = dsWrox.Tables["tabPayments"].NewRow();
			r["AuthorID"] = 2;
			r["Payment"] = 30;
			dsWrox.Tables["tabPayments"].Rows.Add(r);

			// Insert a Relation among the tables
			DataRelation dr = new DataRelation("AuthorsToPaymentRel",dcID,dcIDFK,true);

			dsWrox.Relations.Add(dr);

			// Print to video
			foreach (DataRow d in dsWrox.Tables["tabAuthors"].Rows)
			{
				Console.WriteLine("Author: {0} {1}",d["Author_FirstName"],d["Author_LastName"]);
				foreach (DataRow childRow in d.GetChildRows(dr))
					Console.WriteLine("Payment: {0}$",childRow["Payment"]);
			}
		
		Msgbox 'Hej'
		}
	}
}
