Public Class Form1
    Inherits System.Windows.Forms.Form

    Private m_ds As DataSet
    Private m_dvm As DataViewManager
    Private m_userTable As DataTable

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        Dim dataViewManager As New DataViewManager()

        m_userTable = New DataTable("USERS")

        BuildTable()

        ' create the DataSet object
        m_ds = New DataSet()

        ' create the DataViewManager object with the DataSte
        m_dvm = New DataViewManager(m_ds)

        m_ds.Tables.Add(m_userTable)

        CopyTable()
        
        CustomizeView()
    End Sub

    Private Function CustomizeView()
        m_dvm.DataViewSettings("USERS").Sort = "USER_NAME"
    End Function

    Private Function CopyTable()

        ' make a copy of the table 
        Dim copiedTable = m_userTable.Copy()

        ' rename the table 
        copiedTable.TableName = "USERS_2"

        ' now modify some of its' data 
        copiedTable.Rows(0)("USER_NAME") = "ADAMSF"
        copiedTable.Rows(0)("FULL_NAME") = "FRANK ADAMS"
        copiedTable.Rows(0)("USER_TYPE") = "Administrator"
        copiedTable.Rows(0)("PASSWORD") = "Administrator"

        ' customize any more rows as you wish
        ' .....

        'finally add this code
        m_ds.Tables.Add(copiedTable)

    End Function



    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents DataGrid1 As System.Windows.Forms.DataGrid
    Friend WithEvents DataGrid2 As System.Windows.Forms.DataGrid
    Friend WithEvents button1 As System.Windows.Forms.Button

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.DataGrid2 = New System.Windows.Forms.DataGrid()
        Me.DataGrid1 = New System.Windows.Forms.DataGrid()
        Me.button1 = New System.Windows.Forms.Button()
        CType(Me.DataGrid2, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'DataGrid2
        '
        Me.DataGrid2.DataMember = ""
        Me.DataGrid2.Location = New System.Drawing.Point(8, 176)
        Me.DataGrid2.Name = "DataGrid2"
        Me.DataGrid2.Size = New System.Drawing.Size(504, 144)
        Me.DataGrid2.TabIndex = 1
        '
        'DataGrid1
        '
        Me.DataGrid1.DataMember = ""
        Me.DataGrid1.Location = New System.Drawing.Point(8, 8)
        Me.DataGrid1.Name = "DataGrid1"
        Me.DataGrid1.Size = New System.Drawing.Size(504, 160)
        Me.DataGrid1.TabIndex = 0
        '
        'button1
        '
        Me.button1.Location = New System.Drawing.Point(432, 328)
        Me.button1.Name = "button1"
        Me.button1.TabIndex = 2
        Me.button1.Text = "Fill"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(520, 357)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.button1, Me.DataGrid2, Me.DataGrid1})
        Me.Name = "Form1"
        Me.Text = "Form1"
        CType(Me.DataGrid2, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub BuildTable()

        'create the columns for the table
        Dim userIDCol = New DataColumn("USER_ID", GetType(Int64))
        Dim userNameCol As DataColumn
        Dim fullNameCol As DataColumn
        Dim userTypeCol As DataColumn
        Dim passWordCol As DataColumn

        userNameCol = New DataColumn("USER_NAME", GetType(String))
        fullNameCol = New DataColumn("FULL_NAME", GetType(String))
        userTypeCol = New DataColumn("USER_TYPE", GetType(String))
        passWordCol = New DataColumn("PASSWORD", GetType(String))

        'add the columns to the tables' columns collection
        m_userTable.Columns.Add(userIDCol)
        m_userTable.Columns.Add(userNameCol)
        m_userTable.Columns.Add(fullNameCol)
        m_userTable.Columns.Add(userTypeCol)
        m_userTable.Columns.Add(passWordCol)

        Dim columns(1) As DataColumn

        columns(0) = userNameCol

        m_userTable.PrimaryKey = columns

        'now create some new rows to store the user info
        Dim row1 As DataRow
        Dim row2 As DataRow
        Dim row3 As DataRow
        Dim row4 As DataRow
        Dim row5 As DataRow
        Dim row6 As DataRow
        Dim row7 As DataRow
        Dim row8 As DataRow

        row1 = m_userTable.NewRow()
        row2 = m_userTable.NewRow()
        row3 = m_userTable.NewRow()
        row4 = m_userTable.NewRow()
        row5 = m_userTable.NewRow()
        row6 = m_userTable.NewRow()
        row7 = m_userTable.NewRow()
        row8 = m_userTable.NewRow()

        ' set the information for each user 
        row1("USER_ID") = 1
        row1("USER_NAME") = "DICKINSONP"
        row1("FULL_NAME") = "Paul Dickinson"
        row1("USER_TYPE") = "Administrator"
        row1("PASSWORD") = "Sausages"

        row2("USER_ID") = 2
        row2("USER_NAME") = "SMITHL"
        row2("FULL_NAME") = "Larry Smith"
        row2("USER_TYPE") = "User"
        row2("PASSWORD") = "SMITHL"

        row3("USER_ID") = 3
        row3("USER_NAME") = "ODELLS"
        row3("FULL_NAME") = "Sue O'Dell"
        row3("USER_TYPE") = "Manager"
        row3("PASSWORD") = "Index Finger"

        row4("USER_ID") = 4
        row4("USER_NAME") = "HARRISC"
        row4("FULL_NAME") = "Claire Harris"
        row4("USER_TYPE") = "User"
        row4("PASSWORD") = "Parsnip"

        row5("USER_ID") = 5
        row5("USER_NAME") = "BRIGGSK"
        row5("FULL_NAME") = "Keith Briggs"
        row5("USER_TYPE") = "User"
        row5("PASSWORD") = "Fred"

        row6("USER_ID") = 6
        row6("USER_NAME") = "LITTLEN"
        row6("FULL_NAME") = "Ned Little"
        row6("USER_TYPE") = "Manager"
        row6("PASSWORD") = "BingoHall"

        row7("USER_ID") = 7
        row7("USER_NAME") = "CULLENT"
        row7("FULL_NAME") = "Tim Cullen"
        row7("USER_TYPE") = "User"
        row7("PASSWORD") = "Tights"

        row8("USER_ID") = 8
        row8("USER_NAME") = "WARRINGTONJ"
        row8("FULL_NAME") = "Jan Warrington"
        row8("USER_TYPE") = "User"
        row8("PASSWORD") = "Pesky Kids"

        ' add the rows to table
        m_userTable.Rows.Add(row1)
        m_userTable.Rows.Add(row2)
        m_userTable.Rows.Add(row3)
        m_userTable.Rows.Add(row4)
        m_userTable.Rows.Add(row5)
        m_userTable.Rows.Add(row6)
        m_userTable.Rows.Add(row7)
        m_userTable.Rows.Add(row8)

        ' confirm the changes we've made to the table 
        m_userTable.AcceptChanges()

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub

    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
        DataGrid1.SetDataBinding(m_dvm, "USERS")
        DataGrid2.SetDataBinding(m_dvm, "USERS_2")
    End Sub

End Class
