using System;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Configuration;

namespace DayOfDotNet
{
	public class CustomerOrderDataGrid : System.Web.UI.Page
	{
		protected DataGrid CustomerDataGrid;
		private DataSet ds = new DataSet();

		private void Page_Load(object sender, System.EventArgs e)
		{
			string sqlStmt = "SELECT * FROM Customers; SELECT * FROM Orders";
			string conString = ConfigurationSettings.AppSettings["NWDConString"];
			
			SqlDataAdapter sda = new SqlDataAdapter(sqlStmt, conString);

			sda.Fill(ds);
			ds.Tables[0].TableName = "Customers";
			ds.Tables[1].TableName = "Orders";
			
			CustomerDataGrid.DataSource = ds.Tables["Customers"];
			CustomerDataGrid.DataBind();
		}

		//Use the OnItemDataBound event handler to dynamically add an embedded DataGrid
		protected void CustomerDataGrid_OnItemDataBound(object sender, DataGridItemEventArgs e)
		{
			//When each row is created in the DataGrid, eval the ItemType
			if(e.Item.ItemType == ListItemType.Item || 
				e.Item.ItemType == ListItemType.AlternatingItem)
			{
				//If the ItemType is Item or AlternatingItem, 
				//Create a new DataGrid object named OrdersDataGrid
				DataGrid OrdersDataGrid = new DataGrid();
				
				//Format the DataGrid to look cool.
				OrdersDataGrid.BorderWidth = (Unit)1;
				OrdersDataGrid.CellPadding = 4;
				OrdersDataGrid.CellSpacing = 0;
				OrdersDataGrid.GridLines = GridLines.Horizontal;
				OrdersDataGrid.BorderColor = Color.FromName("Black");
				
				OrdersDataGrid.ItemStyle.Font.Name = "Verdana";
				OrdersDataGrid.ItemStyle.Font.Size = FontUnit.XSmall;
				
				OrdersDataGrid.AlternatingItemStyle.BackColor = Color.FromName("LightGray");
				
				OrdersDataGrid.ShowHeader = true;
				OrdersDataGrid.HeaderStyle.BackColor = Color.FromName("Black");
				OrdersDataGrid.HeaderStyle.ForeColor = Color.FromName("White");
				OrdersDataGrid.HeaderStyle.Font.Bold = true;
				OrdersDataGrid.HeaderStyle.Font.Size = FontUnit.XSmall;

				
				//Do not autogenerate columns.
				OrdersDataGrid.AutoGenerateColumns = false;
				
				//****Add a series of BoundColumns****//
				//***Order ID***//
				BoundColumn bc = new BoundColumn();
				//Set the BoundColumn Values
				bc.HeaderText = "Order ID";
				bc.DataField = "OrderID";
				bc.ItemStyle.Wrap = false;
				//Add the BoundColumn to the OrdersDataGrid.
				OrdersDataGrid.Columns.Add(bc);

				//***Order Date***//
				bc = new BoundColumn();
				bc.HeaderText = "Order Date";
				bc.DataField = "OrderDate";
				bc.DataFormatString="{0:d}";
				bc.ItemStyle.Wrap = false;
				OrdersDataGrid.Columns.Add(bc);

				//***Required Date***//
				bc = new BoundColumn();
				bc.HeaderText = "Required Date";
				bc.DataField = "RequiredDate";
				bc.DataFormatString="{0:d}";
				bc.ItemStyle.Wrap = false;
				OrdersDataGrid.Columns.Add(bc);

				//***Shipped Date***//
				bc = new BoundColumn();
				bc.HeaderText = "Shipped Date";
				bc.DataField = "ShippedDate";
				bc.DataFormatString="{0:d}";
				bc.ItemStyle.Wrap = false;
				OrdersDataGrid.Columns.Add(bc);
				
				//****End BoundColumns****//
				
				
				//Get the Authors DataView and filter it for the current ISBN
				DataView _orders = ds.Tables["Orders"].DefaultView;
				_orders.RowFilter = "CustomerID='" + e.Item.Cells[0].Text + "'";
				
				//Bind the DataGrid.
				OrdersDataGrid.DataSource = _orders;
				OrdersDataGrid.DataBind();
				
				//Add the OrdersDataGrid to the BooksDataGrid.
				e.Item.Cells[3].Controls.Add(OrdersDataGrid);
			}
		}
	}
}