Imports System
Imports System.Data
Imports System.Drawing
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls

Namespace DayOfDotNet

	Public Class SortingDataGrid2
		Inherits System.Web.UI.Page

		Protected DataGrid1 As DataGrid

		Private Sub Page_Load(sender As object, e As System.EventArgs)
			If Not Page.IsPostBack Then
				'On the first request, Bind the DataGrid
				BindData()
			End If
		End Sub

		Private Sub BindData()
			'Create the DataView
			Dim _booksData As BooksData = New BooksData()
			Dim _data As DataView = _booksData.GetAllBooks()

			'If the ViewState SortExpression key has a value, 
			'sort the DataView, otherwise just bind the DataGrid
			If Not ViewState("SortExpression") = Nothing Then
				_data.Sort = ViewState("SortExpression").ToString()
			End If
			
			'Bind the DataGrid
			DataGrid1.DataSource = _data
			DataGrid1.DataBind()
		End Sub
		
		Protected Sub SortCommand_OnClick(sender As Object, e As DataGridSortCommandEventArgs)
			'When a sort link is clicked, bind the 
			'DataGrid using the SortExpression
			'Since we will have alternating sorting, 
			'invoke the GetSortExpression() method
			'to put the sort expression with the
			'ASC or DESC attribute appended on it 
			'into ViewState
			GetSortExpression(e.SortExpression)
			BindData()
		End Sub

		Private Sub GetSortExpression(_sortExpression As String)			
			If ViewState("SortExpression") = Nothing Then
				'If the sort expression has not been put in
				'ViewState yet, do it now and return the
				'sort expression appended with ASC
				ViewState("SortExpression") = _sortExpression & " ASC"
			ElseIf (ViewState("SortExpression").ToString()).StartsWith(_sortExpression) Then
				'If the sort expression is the same column the user clicked on
				'Check the sort direction
				If (ViewState("SortExpression").ToString()).EndsWith("ASC") Then
					'If the sort direction is ASC, make it DESC
					'If it is DESC make it ASC
					ViewState("SortExpression") =  _sortExpression & " DESC"
				Else
					ViewState("SortExpression") =  _sortExpression & " ASC"
				End If
			Else
				'If the sort expression is a different column that the last
				'sort expression, set the New sort expression in ViewState
				'and make its direction ASC
				ViewState("SortExpression") = _sortExpression & " ASC"
			End If
		End Sub
	End Class
End Namespace