namespace PowerOfDotNet.Clubs.Board
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Collections;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using MyWebLibs.Utilities;

	/// <summary>
	///		ContentBody   Դϴ.
	/// </summary>
	public abstract class ClubContentBody : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.DataList BodyList;
		protected System.Web.UI.WebControls.Panel pnlHeader;

		private PowerOfDotNet.Components.BoardClubInfo _blInfo;
		private ArrayList _parsedParams;

		public string ReturnPage
		{
			get{
				object o = ViewState["returnPage"];
				return (o == null) ? "0" : (string)o;
			}
			set{
				ViewState["returnPage"] = value;
			}
		}

		public string SearchTime
		{
			get
			{
				object o = ViewState["searchTime"];
				return (o == null) ? "0" : (string)o;
			}
			set
			{
				ViewState["searchTime"] = value;
			}
		}

		public string SearchSqls
		{
			get
			{
				object o = ViewState["searchSqls"];
				return (o == null) ? "0" : (string)o;
			}
			set
			{
				ViewState["searchSqls"] = value;
			}
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			//  ´.
			int boardId = CommonMethods.RequestInt(Request.Params["TableId"], -1);

			//߱Ⱓ  ̷ Ѵ.
			this.RemoveObjectCache("BoardClubTableInfo" + boardId);
			//ɽÿ   ´.
			_blInfo = (PowerOfDotNet.Components.BoardClubInfo)this.GetObjectFromCache("BoardClubTableInfo" + boardId);
			if (_blInfo == null)
			{
				PowerOfDotNet.Components.BoardClubDB db = new PowerOfDotNet.Components.BoardClubDB();
				_blInfo = db.GetBoardInfo(boardId);

				this.SetObjectToCache("BoardClubTableInfo" + boardId, _blInfo, 30);
			}

			pnlHeader.Style["text-align"] = "center";
			//ŸƲ 
			switch (_blInfo.BBSDisplayType)
			{
				case 0 :
					pnlHeader.Controls.Add(new LiteralControl(_blInfo.BBSSubject));
					pnlHeader.Style["font-size"] = "16px";
					pnlHeader.Style["font-weight"] = "bold";
					break;
				case 1 :
					pnlHeader.Controls.Add(new LiteralControl("<img src='" + _blInfo.BBSImage + "' />"));
					break;
				case 2 :
					pnlHeader.Controls.Add(new LiteralControl(_blInfo.BBSHtml));
					break;
			}
			//_blInfo.BBSDisplayType


			if (!IsPostBack)
			{
				ReturnPage = CommonMethods.RequestStr(Request.Params["page"], "0");
				SearchTime = CommonMethods.RequestStr(Request.Params["searchtime"], "0");
				SearchSqls = CommonMethods.RequestStr(Request.Params["sqls"], "");
				int num = 0;
				_parsedParams = new ArrayList();
				string groupParam;
				while ((groupParam = Request.Params["group" + num.ToString()]) != null)
				{
					string[] aG = groupParam.Split(new Char[] {':'});
					if (aG.Length != 2)
						throw new Exception("group" + num.ToString() + "  ùٸ ʽϴ.");

					string[] aP = aG[1].Split(new Char[] {','});
					if (aG.Length < 1)
						throw new Exception("group" + num.ToString() + "  ùٸ ʽϴ.");

					//MID PID ä 
					MidGroup mg = new MidGroup(Convert.ToInt32(aG[0]), Convert.ToInt32(aP[0]));
					//PID  
					for (int i=1; i<aP.Length; i++)
						mg.AddPid(Convert.ToInt32(aP[i]));

					_parsedParams.Add(mg);
					num++;
				}
				
			}
			else
			{
				_parsedParams = (ArrayList)ViewState["parsedParams"];
			}
			BodyList.DataSource = _parsedParams;
			BodyList.DataBind();

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.BodyList.PreRender += new System.EventHandler(this.BodyList_PreRender);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void BodyList_PreRender(object sender, System.EventArgs e)
		{
			//ȸ 
			this.Session["ClubForVistedIncrease"] = Request.RawUrl;

			//Ʒ ϸ Ʒ⿡  ??
			//BodyList.DataBind();
			//this.DataBind();
			// _parsedParams   UriĶŸ   
			//Redirect   ٽ ȣѴ.
			int changedPID = 0;
			// ־ ˾ƺ.
			foreach (MidGroup mg in _parsedParams)
			{
				if (mg.ChangedPID != 0)
				{
					changedPID = mg.ChangedPID;
					mg.ChangedPID = 0;
				}
			}

			if (changedPID != 0)
			{
				string param = "";
				int groupNum = 0;
				foreach (MidGroup mg in _parsedParams)
				{
					string subParam = "";
					foreach (int pid in mg.PIDs)
						subParam += "," + pid.ToString();

					subParam = subParam.Substring(1); //տ ',' 

					param += "&group" + groupNum.ToString() + "=" + mg.MID.ToString() + ":" + subParam;
					groupNum++;
				}

				param = Request.RawUrl.Substring(0, Request.RawUrl.IndexOf("&group0")) + param;
				Response.Redirect(param);
			}
			else
			{
				ViewState["parsedParams"] = _parsedParams;
			}
		}
	}

	[Serializable]
	public sealed class MidGroup
	{
		private int _mid;
		private ArrayList _pids;
		private int _changedPid;

		public int ChangedPID
		{
			get {
				return _changedPid;
			}
			set {
				_changedPid = value;
			}
		}

		public int Count
		{
			get {
				return _pids.Count;
			}
		}

		public ArrayList PIDs
		{
			get {
				return _pids;
			}
		}

		public int MID
		{
			get {
				return _mid;
			}
		}

		public MidGroup(int mid, int pid)
		{
			_mid = mid;
			_pids = new ArrayList();
			_pids.Add(pid);
			_changedPid = 0;
		}

		public void AddPid(int pid)
		{
			_pids.Add(pid);
		}
	}
}
