namespace PowerOfDotNet.Clubs
{
	using System;
	using System.Collections;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		ClubClassList   Դϴ.
	/// </summary>
	public abstract class ClubClassList : PowerOfDotNet.PortalModuleControlEx
	{
		protected MyWebLibs.ServerControls.PagerSkinGrid pgrskngrdClubList;
		protected string[] _publicTypeName = new string[] {"Free", "", ""};
		protected string _subMainLink;

		private int _dataBoundCount = 0;
		private PowerOfDotNet.Components.ClubsDB _db;
		private string _userId;
		protected System.Web.UI.WebControls.Label lblClassCategory;
		private bool _isAdmin;

		private void Page_Load(object sender, System.EventArgs e)
		{
			// ˻
			_isAdmin = Clubs.ClubsUtil.CheckUserIsAdmin(_userId);
			if (!this.IsPostBack)
			{
				int classId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["classId"], -1);
				if (classId == -1)
					throw new Exception("  classId ĶͰ ʿմϴ.");

				pgrskngrdClubList.CurrentPageIndex = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["page"], 0);

				_db = new PowerOfDotNet.Components.ClubsDB();
				SqlDataReader dr = _db.GetClass(classId);
				dr.Read();
				lblClassCategory.Text = dr["Name"].ToString();
				dr.Close();

				this.ViewState["classId"] = classId;
				_subMainLink = GetLink("Ŭ");
				BindData();
			}
		}

		private void BindData()
		{
			DataSet ds = _db.GetClubList((int)this.ViewState["classId"]);
			_userId = this.Page.User.Identity.Name;

			pgrskngrdClubList.DataSource = ds.Tables[0].DefaultView;
			pgrskngrdClubList.DataBind();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.pgrskngrdClubList.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler(this.pgrskngrdClubList_ItemDataBound);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void pgrskngrdClubList_ItemDataBound(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.Item || 
				e.Item.ItemType == ListItemType.AlternatingItem)
			{
				if (((ICollection)((DataGrid)sender).DataSource).Count > _dataBoundCount)
				{
					string link = String.Empty;
					int clubId = Convert.ToInt32(e.Item.Cells[0].Text);
					DataRowView drv = (DataRowView)e.Item.DataItem;
					byte publicType = (byte)drv["PublicType"];

					HtmlInputButton btnJoin = (HtmlInputButton)e.Item.Cells[1].FindControl("btnJoin");

					if (!Request.IsAuthenticated) {
						btnJoin.Attributes["onclick"] = "NotYetLogined();";
						link = "javascript:NotYetLogined()";
					}
					else if (_isAdmin || publicType == 0) {
						link = _subMainLink +"&clubId=" + clubId;

						int result = _db.CheckClubUser(clubId, _userId);
						if (result == 1) //̹ ԵǾ
							btnJoin.Disabled = true;
						else // ԾʵǾ
							btnJoin.Attributes["onclick"] = "OpenWin(" + clubId.ToString() + ")";
					}
					else {
						int result = _db.CheckClubUser(clubId, _userId);

						switch (result)	{
							case 1 : // ȸ
								link = _subMainLink +"&clubId=" + clubId;
								//((DataRowView)e.Item.DataItem)["ID"];
								btnJoin.Disabled = true;
								break;
							case -1 : // ̰
								link = "javascript:DoNotAccess()";
								//׼ ź
								btnJoin.Attributes["onclick"] = "OpenWin(" + clubId.ToString() + ")";
								break;
							case 0 : // ó ̰
								link = "javascript:NotYetAgreement(" + clubId + ", " + 
									this.ViewState["classId"].ToString() + "," + pgrskngrdClubList.CurrentPageIndex + ")";
								// ũƮ ŻóѴ.
								btnJoin.Disabled = true;
								break;
						}
					}
					HtmlAnchor a = (HtmlAnchor)e.Item.Cells[1].FindControl("hacClubLnk");
					a.Attributes["href"] = link;
					_dataBoundCount++; // ޼ҵ尡 ѹ̻ ݺǴ 찡 Ƿ
				}
			}
		}
	}
}
