namespace PowerOfDotNet.Clubs
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Collections;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		ClubsMain   Դϴ.
	/// </summary>
	public abstract class ClubsMain : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.HyperLink hyplnkEnter;
		protected System.Web.UI.WebControls.Label lblID;
		protected System.Web.UI.WebControls.DataList datlstNewClubs;
		protected System.Web.UI.WebControls.DataList datlstBestClubs;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstSearchMethod;
		protected System.Web.UI.WebControls.TextBox txtSearch;
		protected System.Web.UI.WebControls.Button btnSearch;

		protected System.Web.UI.WebControls.Label lblSearchCondition;
		protected MyWebLibs.ServerControls.PagerSkinGrid pgrskngrdClubList;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator2;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator3;
		protected MyWebLibs.ServerControls.MyValidationSummry MyValidationSummry1;
		protected System.Web.UI.WebControls.PlaceHolder PlaceHolder1;
		protected System.Web.UI.WebControls.PlaceHolder Placeholder2;

		protected string[] _publicTypeName = new string[] {"Free", "", ""};
		protected string _subMainLink;

		private int _dataBoundCount = 0;
		private bool _isAdmin;
		private string _userId;
		private PowerOfDotNet.Components.ClubsDB _db;

		private void Page_Load(object sender, System.EventArgs e)
		{
			_userId = this.Page.User.Identity.Name;
			// ˻
			_isAdmin = Clubs.ClubsUtil.CheckUserIsAdmin(_userId);
			_subMainLink = GetLink("Ŭ");

			_db = new PowerOfDotNet.Components.ClubsDB();

			if (!this.IsPostBack) {
				// λ Ŭ 
				DataSet dsCD = _db.GetClubListOrderByCreatedDate();
				datlstNewClubs.DataSource = dsCD.Tables[0].DefaultView;
				datlstNewClubs.DataBind();

				//   ʱȭ
				_dataBoundCount = 0;
				// α Ŭ 
				DataSet dsBC = _db.GetClubListOrderByMemberCount();
				datlstBestClubs.DataSource = dsBC.Tables[0].DefaultView;
				datlstBestClubs.DataBind();

				txtSearch.Attributes["onkeypress"] = "if (event.keyCode==13 && Page_ClientValidate()) {" + 
					Page.GetPostBackEventReference(btnSearch,"") + ";return false;}";
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnSearch.Click += new System.EventHandler(this.btnSearch_Click);
			this.datlstNewClubs.ItemDataBound += new System.Web.UI.WebControls.DataListItemEventHandler(this.datlstNewClubs_ItemDataBound);
			this.datlstBestClubs.ItemDataBound += new System.Web.UI.WebControls.DataListItemEventHandler(this.datlstBestClubs_ItemDataBound);
			this.pgrskngrdClubList.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler(this.pgrskngrdClubList_ItemDataBound);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void datlstNewClubs_ItemDataBound(object sender, System.Web.UI.WebControls.DataListItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.Item || 
				e.Item.ItemType == ListItemType.AlternatingItem) {
				//  ׸ ѹ  ε ǵѴ.
				if (((ICollection)((DataList)sender).DataSource).Count > _dataBoundCount) {
					string link = String.Empty;
					DataRowView drv = (DataRowView)e.Item.DataItem;
					byte publicType = (byte)drv["PublicType"];
					int clubId = (int)drv["ID"];

					// [] ư
					HtmlAnchor hacJoin = (HtmlAnchor)e.Item.FindControl("hacJoin");

					// α   
					if (!Request.IsAuthenticated) {
						hacJoin.Attributes["href"] = "javascript:NotYetLogined();";
						link = "javascript:NotYetLogined()";
					}
					// ڰ ̰ų Ŭ  Free
					else if (_isAdmin || publicType == 0) {
						link = _subMainLink +"&clubId=" + clubId;

						int result = _db.CheckClubUser(clubId, _userId);
						if (result == 1) //̹ ԵǾ
							hacJoin.Disabled = true;
						else // ԾʵǾ
							hacJoin.Attributes["href"] = "javascript:OpenWin(" + clubId.ToString() + ")";
					}
					else {
						int result = _db.CheckClubUser(clubId, _userId);

						switch (result)	{
							case 1 : // ȸ
								link = _subMainLink +"&clubId=" + clubId;
								//((DataRowView)e.Item.DataItem)["ID"];
								hacJoin.Disabled = true;
								break;
							case -1 : // ̰
								link = "javascript:DoNotAccess()";
								//׼ ź
								hacJoin.Attributes["href"] = "javascript:OpenWin(" + clubId.ToString() + ")";
								break;
							case 0 : // ó ̰
								//Ż ó  .
								link = "javascript:NotYetAgreement(" + clubId + ")";
								hacJoin.Disabled = true;
								break;
						}
					}
					// Ŭ  ũ
					HtmlAnchor a = (HtmlAnchor)e.Item.FindControl("hacClubLnk");
					a.Attributes["href"] = link;
					_dataBoundCount++; // ޼ҵ尡 ѹ̻ ݺǴ 찡 Ƿ
				}
			}
		}

		private void datlstBestClubs_ItemDataBound(object sender, System.Web.UI.WebControls.DataListItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.Item || 
				e.Item.ItemType == ListItemType.AlternatingItem) {
				//  ׸ ѹ  ε ǵѴ.
				if (((ICollection)((DataList)sender).DataSource).Count > _dataBoundCount) {
					string link = String.Empty;
					DataRowView drv = (DataRowView)e.Item.DataItem;
					byte publicType = (byte)drv["PublicType"];
					int clubId = (int)drv["ID"];

					// [] ư
					HtmlAnchor hacJoin = (HtmlAnchor)e.Item.FindControl("hacJoin");

					// α   
					if (!Request.IsAuthenticated) {
						hacJoin.Attributes["href"] = "javascript:NotYetLogined();";
						link = "javascript:NotYetLogined()";
					}
					// ڰ ̰ų Ŭ  Free
					else if (_isAdmin || publicType == 0) {
						link = _subMainLink +"&clubId=" + clubId;

						int result = _db.CheckClubUser(clubId, _userId);
						if (result == 1) //̹ ԵǾ
							hacJoin.Disabled = true;
						else // ԾʵǾ
							hacJoin.Attributes["href"] = "javascript:OpenWin(" + clubId.ToString() + ")";
					}
					else {
						int result = _db.CheckClubUser(clubId, _userId);

						switch (result)	{
							case 1 : // ȸ
								link = _subMainLink +"&clubId=" + clubId;
								//((DataRowView)e.Item.DataItem)["ID"];
								hacJoin.Disabled = true;
								break;
							case -1 : // ̰
								link = "javascript:DoNotAccess()";
								//׼ ź
								hacJoin.Attributes["href"] = "javascript:OpenWin(" + clubId.ToString() + ")";
								break;
							case 0 : // ó ̰
								//Żó  .
								link = "javascript:NotYetAgreement(" + clubId + ")";
								hacJoin.Disabled = true;
								break;
						}
					}
					HtmlAnchor a = (HtmlAnchor)e.Item.FindControl("hacClubLnk");
					a.Attributes["href"] = link;
					_dataBoundCount++; // ޼ҵ尡 ѹ̻ ݺǴ 찡 Ƿ
				}
			}
		}

		//Ŭ ˻ ư ̺Ʈ
		private void btnSearch_Click(object sender, System.EventArgs e)
		{
			DataSet ds = null;
			switch (rdobtnlstSearchMethod.SelectedIndex) {
				case 0 :
					ds = _db.GetClubListWhereSubject(txtSearch.Text);
					lblSearchCondition.Text = "Ŭ=" + txtSearch.Text;
					break;
				case 1 :
					ds = _db.GetClubListWhereIntroHtml(txtSearch.Text);
					lblSearchCondition.Text = "ŬҰ=" + txtSearch.Text;
					break;
				case 2 :
					ds = _db.GetClubListWhereSysopId(txtSearch.Text);
					lblSearchCondition.Text = "ûID=" + txtSearch.Text;
					break;
			}
			//˻ Ŭ   ȯ
			PlaceHolder1.Visible = false;
			Placeholder2.Visible = true;

			pgrskngrdClubList.DataSource = ds.Tables[0].DefaultView;
			pgrskngrdClubList.DataBind();
		}

		//˻ Ŭ Ʈ ε
		private void pgrskngrdClubList_ItemDataBound(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.Item || 
				e.Item.ItemType == ListItemType.AlternatingItem) {
				if (((ICollection)((DataGrid)sender).DataSource).Count > _dataBoundCount) {
					string link = String.Empty;
					int clubId = Convert.ToInt32(e.Item.Cells[0].Text);
					DataRowView drv = (DataRowView)e.Item.DataItem;
					byte publicType = (byte)drv["PublicType"];

					HtmlInputButton btnJoin = (HtmlInputButton)e.Item.Cells[1].FindControl("btnJoin");

					if (!Request.IsAuthenticated) {
						btnJoin.Attributes["onclick"] = "NotYetLogined();";
						link = "javascript:NotYetLogined()";
					}
					else if (_isAdmin || publicType == 0) {
						link = _subMainLink +"&clubId=" + clubId;

						int result = _db.CheckClubUser(clubId, _userId);
						if (result == 1) //̹ ԵǾ
							btnJoin.Disabled = true;
						else // ԾʵǾ
							btnJoin.Attributes["onclick"] = "OpenWin(" + clubId.ToString() + ")";
					}
					else {
						int result = _db.CheckClubUser(clubId, _userId);

						switch (result)	{
							case 1 : // ȸ
								link = _subMainLink +"&clubId=" + clubId;
								//((DataRowView)e.Item.DataItem)["ID"];
								btnJoin.Disabled = true;
								break;
							case -1 : // ̰
								link = "javascript:DoNotAccess()";
								//׼ ź
								btnJoin.Attributes["onclick"] = "OpenWin(" + clubId.ToString() + ")";
								break;
							case 0 : // ó ̰
								link = "javascript:NotYetAgreement(" + clubId + ")";
								// ũƮ ŻóѴ.
								btnJoin.Disabled = true;
								break;
						}
					}
					HtmlAnchor a = (HtmlAnchor)e.Item.Cells[1].FindControl("hacClubLnk");
					a.Attributes["href"] = link;
					_dataBoundCount++; // ޼ҵ尡 ѹ̻ ݺǴ 찡 Ƿ
				}
			}
		}
	}
}
