using System;
using System.Data;
using System.Data.SqlClient;
using System.EnterpriseServices;
using System.Diagnostics;
using System.Runtime.InteropServices;

namespace MemoDb
{
	[Transaction(TransactionOption.NotSupported)]
	[ObjectPooling(MinPoolSize=1,MaxPoolSize=5)]
	[JustInTimeActivation(true)]
	[ConstructionEnabled(Enabled = true,
		 Default = "server=localhost;database=AspDotNetBook;uid=AspDotNet;pwd=aspdotnet")]
	public class MemoDB_nTx : ServicedComponent
	{
		private SqlConnection conn;
		private string connStr;

		public MemoDB_nTx()
		{
		}

		protected override void Construct(string constructString) 
		{
			connStr = constructString;
		}

		protected override void Activate()
		{
			conn = new SqlConnection(connStr);
		}

		protected override void Deactivate()
		{
			if (conn != null)
			{
				if (conn.State != ConnectionState.Closed )
					conn.Close();

				conn.Dispose();
				conn = null;
			}
		}

		protected override bool CanBePooled()
		{
			return true;
		}

		[AutoComplete]
		public DataSet GetList()
		{
			string sql = "select * from tbMemo";
			SqlCommand command = new SqlCommand(sql, conn);
			command.CommandType = CommandType.Text;

			SqlDataAdapter ad = new SqlDataAdapter(command);
			DataSet ds = new DataSet();
			
			ad.Fill(ds, "tbMemo");
			
			return ds;
		}
	}
}
