using System;
using System.Web;
using System.Drawing;
using System.Drawing.Text;
using System.Drawing.Imaging;

namespace Chapter14.Ex08
{
	public class Chap14_08 : IHttpHandler
	{
		public void ProcessRequest(HttpContext context)
		{
			string fColorStr = context.Request.QueryString["fColor"];
			string bColorStr = context.Request.QueryString["bColor"];
			string text = context.Request.QueryString["text"];
			int angle = Convert.ToInt32(context.Request.QueryString["angle"]);

			Bitmap oImage = new Bitmap(100,100);
			Graphics oGraphics = Graphics.FromImage(oImage);

			try
			{
				Color fColor = ColorTranslator.FromHtml(fColorStr);
				Color bColor = ColorTranslator.FromHtml(bColorStr);

				oGraphics.FillRectangle(new SolidBrush(bColor),0,0,100,100);
				
				oGraphics.TextRenderingHint = TextRenderingHint.AntiAlias;
				oGraphics.RotateTransform(angle);
				oGraphics.DrawString(text,new Font("", 16.0F),
					new SolidBrush(fColor), 25.0F, 40.0F, new StringFormat());
				oImage.Save(context.Response.OutputStream, ImageFormat.Gif);
			}
			catch (	Exception err)
			{
				string s = err.Message;
				oGraphics.FillRectangle(new SolidBrush(Color.Wheat),0,0,100,100);
				oGraphics.DrawString(" ߻!",new Font("", 14.0F),
					new SolidBrush(Color.Black), 20.0F, 40.0F, new StringFormat());
				oImage.Save(context.Response.OutputStream, ImageFormat.Gif);
			}
			finally
			{
				oGraphics.Dispose();
				oImage.Dispose();
			}
		}

		public bool IsReusable
		{
			get { return true; }
		}
	}
}