using System;
using System.Web;
using System.Configuration;

namespace HTTPModules.Ex03
{
	public class ErrorLog : IHttpModule
	{
		private HttpApplication _application;

		public void Init(System.Web.HttpApplication application)
		{
			application.Error += new System.EventHandler(error);
			_application = application;
		}

		public void error(object sender, EventArgs e)
		{
			string errorMassage = "\n !! ";
			errorMassage += "\nURL : " + _application.Request.RawUrl;
			errorMassage += "\n޼ : " + _application.Context.Error.Message;
			errorMassage += "\nStackTrace : " + _application.Context.Error.StackTrace;

			WriteMessage.WriteToFile(errorMassage);

			string errPage = ConfigurationSettings.AppSettings["ErrorPage"];

			if (errPage == null)
				errPage = "ErrorReport.aspx";

			errPage = _application.Request.ApplicationPath + "/" + errPage;
			errPage += "?SourcePage=" + _application.Request.FilePath;
			_application.Response.Redirect(errPage);
		}

		public void Dispose()
		{
		}
	}
}
