using System;
using System.Web;

namespace HTTPModules.Ex04
{
	public class ChangePath : IHttpModule
	{
		private HttpApplication _application;

		public void Init(System.Web.HttpApplication application)
		{
			application.AuthenticateRequest += new System.EventHandler(authenticateRequest);
			_application = application;
		}

		public void authenticateRequest(object sender, EventArgs e)
		{
			if (_application.Request.IsAuthenticated && 
				_application.Request.FilePath.ToLower().IndexOf("/ex04/home.aspx") > 0)
			{
				string lowerUrl = _application.Request.RawUrl.ToLower();
				int pagePos = lowerUrl.IndexOf("/home.aspx");
				string userId = _application.User.Identity.Name;
				string userHome = lowerUrl.Substring(0, pagePos);
				userHome += "/users/" + userId;
				userHome += _application.Request.RawUrl.Substring(pagePos);
				_application.Context.RewritePath(userHome);
			}
		}

		public void Dispose()
		{
		}
	}
}
