using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Web.UI.WebControls;
using System.Configuration;

namespace Chapter19
{
	public class DefaultPaging : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.RadioButtonList RadioButtonList1;
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				BindData();
			}
		}

		private void BindData()
		{
			DataView dv = GetData();

			DataGrid1.DataSource = dv;
			DataGrid1.DataBind();
		}

		public DataView GetData()
		{
			string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "select * from tbDataPresentation2_Orders";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlDataAdapter da = new SqlDataAdapter(strQuery, sqlConn);

			DataSet ds = new DataSet();
			da.Fill(ds, "DataPresentation2_Orders");
			return ds.Tables["DataPresentation2_Orders"].DefaultView;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.DataGrid1.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid1_ItemCommand);
			this.DataGrid1.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.DataGrid1_PageIndexChanged);
			this.RadioButtonList1.SelectedIndexChanged += new System.EventHandler(this.RadioButtonList1_SelectedIndexChanged);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void DataGrid1_PageIndexChanged(object source, System.Web.UI.WebControls.DataGridPageChangedEventArgs e)
		{
			((DataGrid)source).CurrentPageIndex = e.NewPageIndex;
			BindData();
		}

		private void RadioButtonList1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (RadioButtonList1.SelectedItem.Value == "1")
				DataGrid1.PagerStyle.Mode = PagerMode.NextPrev;
			else
				DataGrid1.PagerStyle.Mode = PagerMode.NumericPages;

			BindData();
		}

		private void DataGrid1_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			Response.Write("CommandName : " + e.CommandName + 
				"<br>" + "CommandArgument : " + e.CommandArgument);
		}
	}
}
