using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;
using System.Collections.Specialized;

namespace CustomControls.Ex11
{
	public class Ex11_Control : WebControl, IPostBackDataHandler
	{
		public event EventHandler TextChanged;

		public string Text {
			get	{
				object o = ViewState["text"];
				return (o == null) ? String.Empty : (string)o;
			}
			set	{ViewState["text"] = value;}
		}

		public Ex11_Control() : base(HtmlTextWriterTag.Input) {}

		public bool LoadPostData(string postDataKey, 
			NameValueCollection postCollection)
		{
			string newVal = postCollection[postDataKey];

			if(Text != newVal) {
				Text = newVal;
				return true;
			}
			return false;
		}

		public void RaisePostDataChangedEvent()
		{
			if (TextChanged != null)
				TextChanged(this, EventArgs.Empty);
		}

		protected override void AddAttributesToRender(HtmlTextWriter writer)
		{
			writer.AddAttribute(HtmlTextWriterAttribute.Name, UniqueID);
			writer.AddAttribute(HtmlTextWriterAttribute.Type, "input");
			writer.AddAttribute(HtmlTextWriterAttribute.Value, Text);
			base.AddAttributesToRender(writer);
		}
	}
}