using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace CustomControls.Ex14
{
	public class Ex14_Control : Control, IPostBackEventHandler, IPostBackDataHandler
	{
		public event EventHandler AddCalculated;
		public event EventHandler SubCalculated;

		public int Result {
			set	{ViewState["Result"] = value;}
			get	{
				object o = ViewState["Result"];
				return (o == null) ? 0: (int)o;
			}
		}

		private int selectedIndex1 {
			set {ViewState["selIdx1"] = value;}
			get {
				object o = ViewState["selIdx1"];
				return (o == null) ? -1: (int)o;
			}
		}

		private int selectedIndex2
		{
			set {ViewState["selIdx2"] = value;}
			get {
				object o = ViewState["selIdx2"];
				return (o == null) ? -1: (int)o;
			}
		}

		protected override void Render(HtmlTextWriter writer)
		{
			writer.RenderBeginTag(HtmlTextWriterTag.H3);
			writer.Write("ϱ/ Ʈ");
			writer.RenderEndTag();
			writer.WriteLine();

			int selectedIndex = selectedIndex1;
			writer.AddAttribute(HtmlTextWriterAttribute.Name, UniqueID);
			writer.RenderBeginTag(HtmlTextWriterTag.Select);
			for (int i=0;i<20;i++)	{
				if (selectedIndex == i)
					writer.AddAttribute(HtmlTextWriterAttribute.Selected, null);
				writer.AddAttribute(HtmlTextWriterAttribute.Value, i.ToString());
				writer.RenderBeginTag(HtmlTextWriterTag.Option);
				writer.Write(i.ToString());
				writer.RenderEndTag();
				writer.WriteLine();
			}
			writer.RenderEndTag();
			writer.WriteLine();

			writer.WriteLine(" + | - ");

			selectedIndex = selectedIndex2;
			writer.AddAttribute(HtmlTextWriterAttribute.Name, UniqueID + ":sel2");
			writer.RenderBeginTag(HtmlTextWriterTag.Select);
			for (int i=0;i<20;i++)	{
				if (selectedIndex == i)
					writer.AddAttribute(HtmlTextWriterAttribute.Selected, null);
				writer.AddAttribute(HtmlTextWriterAttribute.Value, i.ToString());
				writer.RenderBeginTag(HtmlTextWriterTag.Option);
				writer.Write(i.ToString());
				writer.RenderEndTag();
				writer.WriteLine();
			}
			writer.RenderEndTag();
			writer.WriteLine();
			writer.Write(" = " + Result);
			writer.WriteLine("<br><br>");

			writer.AddAttribute(HtmlTextWriterAttribute.Onclick, Page.GetPostBackEventReference(this, "add"));
			writer.AddAttribute(HtmlTextWriterAttribute.Type,"button");
			writer.AddAttribute(HtmlTextWriterAttribute.Value,"ϱ");
			writer.RenderBeginTag(HtmlTextWriterTag.Input);
			writer.RenderEndTag();
			writer.WriteLine();

			writer.AddAttribute(HtmlTextWriterAttribute.Onclick, Page.GetPostBackEventReference(this, "sub"));
			writer.AddAttribute(HtmlTextWriterAttribute.Type,"button");
			writer.AddAttribute(HtmlTextWriterAttribute.Value,"");
			writer.RenderBeginTag(HtmlTextWriterTag.Input);
			writer.RenderEndTag();
		}
		
		public void RaisePostBackEvent(string eventArgument)
		{
			if (eventArgument == "add") {
				Result = selectedIndex1 + selectedIndex2;
				if (AddCalculated != null)
					AddCalculated(this, EventArgs.Empty);
			}
			else if (eventArgument == "sub") {
				Result = selectedIndex1 - selectedIndex2;
				if (SubCalculated != null)
					SubCalculated(this, EventArgs.Empty);
			}
		}

		public bool LoadPostData(string postDataKey, System.Collections.Specialized.NameValueCollection postCollection)
		{
			selectedIndex1 = int.Parse(postCollection[postDataKey]);
			selectedIndex2 = int.Parse(postCollection[postDataKey + ":sel2"]);

			return false;
		}

		public void RaisePostDataChangedEvent()	{}
	}
}