using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;

namespace CustomControls.TemplatedControls
{
	/// <summary>
	/// Templated Control  3
	/// </summary>
	[
	ParseChildren(true)
	]
	public class TemplatedControl3 : Control, INamingContainer
	{
		private ITemplate itemTemplate = null;
		private ITemplate alternatingTemplate = null;
		private IEnumerable dataSource = null;

		public IEnumerable DataSource 
		{
			get {return dataSource;}
			set {dataSource = value;}
		}

		[TemplateContainer(typeof(TemplateItem))]
		public ITemplate ItemTemplate 
		{
			get {return itemTemplate;}
			set {itemTemplate = value;}
		}

		[TemplateContainer(typeof(TemplateItem))]
		public ITemplate AlternatingTemplate 
		{
			get {return alternatingTemplate;}
			set {alternatingTemplate = value;}
		}

		protected override void OnDataBinding(System.EventArgs e)
		{
			base.OnDataBinding(e);

			Controls.Clear();

			if (dataSource != null) 
			{
				int count = 0;
				foreach(object dataItem in dataSource)
				{
					TemplateItem item = new TemplateItem(dataItem);
					if (count % 2 == 0 || alternatingTemplate == null)
						ItemTemplate.InstantiateIn(item);
					else
						alternatingTemplate.InstantiateIn(item);

					//OnDataBinding ε ʿ.
					//item.DataBind();
					Controls.Add(item);
					count++;
				}
			}
		}
		
		public class TemplateItem : Control, INamingContainer 
		{
			private object dataItem;

			public TemplateItem(object datItm) 
			{
				dataItem = datItm;
			}

			public object DataItem
			{
				get {return dataItem;}
				set {dataItem = value;}
			}
		}
	}
}
