using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;

namespace CustomControls.TemplatedControls
{
	/// <summary>
	/// Templated Control  4
	/// </summary>
	[
	ParseChildren(true)
	]
	public class TemplatedControl4 : WebControl, INamingContainer
	{
		private ITemplate itemTemplate = null;
		private ITemplate alternatingTemplate = null;
		private IEnumerable dataSource = null;

		public IEnumerable DataSource 
		{
			get {return dataSource;}
			set {dataSource = value;}
		}

		[TemplateContainer(typeof(TemplateItem))]
		public ITemplate ItemTemplate 
		{
			get {return itemTemplate;}
			set {itemTemplate = value;}
		}

		[TemplateContainer(typeof(TemplateItem))]
		public ITemplate AlternatingTemplate 
		{
			get {return alternatingTemplate;}
			set {alternatingTemplate = value;}
		}

		private int ItemCount
		{
			get {
				object o = ViewState["itemCount"];
				if(o == null)
					return 0;
				else
					return (int)o;
			}
			set {ViewState["itemCount"] = value;}
		}

		protected override void CreateChildControls() 
		{
			Controls.Clear();

			if (ItemCount != 0) 
			{
				for (int i=0;i<ItemCount;i++)
				{
					/*******************************************
					 *    Ʈ  Ͱ
					 * item ȴ.
					 * Ʈ Ҷ  Ʈ 
					 * ϸ Ʈѿ   Ʈ 
					 * ڵ Ǵ Ͱ  .
					 *******************************************/
					TemplateItem item = new TemplateItem(null);
					if (i % 2 == 0 || alternatingTemplate == null)
						ItemTemplate.InstantiateIn(item);
					else
						alternatingTemplate.InstantiateIn(item);

					Controls.Add(item);
				}
			}		
		}

		/*
		protected override void OnDataBinding(System.EventArgs e)
		{
			base.OnDataBinding(e);

			Controls.Clear();

			if (dataSource != null) 
			{
				int count = 0;
				foreach(object dataItem in dataSource)
				{
					TemplateItem item = new TemplateItem(dataItem);
					if (count % 2 == 0 || alternatingTemplate == null)
						ItemTemplate.InstantiateIn(item);
					else
						alternatingTemplate.InstantiateIn(item);
						
					//OnDataBinding ε ʿ.
					//item.DataBind();
					Controls.Add(item);
					count++;
				}

				ChildControlsCreated = true;
				ItemCount = count;
			}
		}
		*/
		
		public override void DataBind()
		{
			Controls.Clear();

			if (dataSource != null) 
			{
				int count = 0;
				foreach(object dataItem in dataSource)
				{
					TemplateItem item = new TemplateItem(dataItem);
					if (count % 2 == 0 || alternatingTemplate == null)
						ItemTemplate.InstantiateIn(item);
					else
						alternatingTemplate.InstantiateIn(item);

					//OnDataBinding ε ʿ.
					//item.DataBind();
					Controls.Add(item);
					count++;
				}

				ChildControlsCreated = true;
				ItemCount = count;
			}
			
			//⼭ ڽ Ʈѵ鿡  ε ó Ѵ.
			base.DataBind();
		}

		public class TemplateItem : Control, INamingContainer 
		{
			private object dataItem;

			public TemplateItem(object datItm) 
			{
				dataItem = datItm;
			}

			public object DataItem
			{
				get {return dataItem;}
				set {dataItem = value;}
			}
		}
	}
}
