using System;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace CustomControls.Validators
{
	/// <summary>
	///  ⺻  ߻Ŭ.
	///  Ŭ ؼ پ 
	/// ͸   ִ.
	/// </summary>
	[
	DefaultProperty("ErrorMessage"),
	]
	public abstract class SimpleBaseValidator1 : System.Web.UI.WebControls.Label, IValidator
	{
		private bool isValid;
		
		//DefaultValueAttribute  ϱ 
		[DefaultValue(typeof(Color), "Red")]                                         
		public override Color ForeColor 
		{
			get {return base.ForeColor;}
			set {base.ForeColor = value;}
		}

		[
		Category("Behavior"),
		DefaultValue(""),
		TypeConverter(typeof(ValidatedControlConverter))
		]                                         
		public string ControlToValidate 
		{
			get 
			{ 
				object o = ViewState["ControlToValidate"];
				return((o == null) ? String.Empty : (string)o);
			}
			set {ViewState["ControlToValidate"] = value;}
		}

		[
		Category("Appearance"),
		DefaultValue("")
		]
		public string ErrorMessage 
		{
			get 
			{
				object o = ViewState["ErrorMessage"];
				return((o == null) ? String.Empty : (string)o);
			}
			set {ViewState["ErrorMessage"] = value;}
		}

		[
		Browsable(false),
		DefaultValue(true),
		DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)
		]
			// Է ùٸ 
		public bool IsValid 
		{
			get {return isValid;}
			set {isValid = value;}
		}

		public SimpleBaseValidator1()
		{
			isValid = true;
			// ޼ 
			ForeColor = Color.Red;
		}

		protected string GetControlValidationValue(string name) 
		{
			/*****************************************
			 * ȿ ˻縦  Ʈ ˻簪
			 *  ޼ҵ̴.
			 * ˻縦  Ʈ ̸  
			 * Ʈ ˻簪 ; ϱ 
			 * ÷ Ѵ.
			 *****************************************/
			// ˻ Ʈ ´.
			Control c = NamingContainer.FindControl(name);            
			if (c == null) 
				return null;

			// Ʈѿ ȿ ˻縦  Ӽ PropertyDescriptor ´.
			PropertyDescriptor prop = GetValidationProperty(c);
			if (prop == null) 
				return null;

			// Ӽ  ´.
			object value = prop.GetValue(c);
			if (value is ListItem) 
			{
				return((ListItem) value).Value;
			}
			else if (value != null) 
				return value.ToString();
			else 
				return string.Empty;
		}                

		//־ Ʈ ValidationPropertyAttribute Ʈ  
		//Ӽ ִٸ  Ӽ  PropertyDescriptor ü ȯѴ.
		public static PropertyDescriptor GetValidationProperty(object component) 
		{
			//component ü  ƮƮ ߿ 
			//ValidationPropertyAttribute   ´.
			//ValidationPropertyAttribute   
			//Ӽ ˻簪  ִ.
			ValidationPropertyAttribute valProp = (ValidationPropertyAttribute)TypeDescriptor.GetAttributes(component)[typeof(ValidationPropertyAttribute)];
			if (valProp != null && valProp.Name != null) 
				//valProp.Name  ̸  Ӽ 
				//PropertyDescriptor ü ȯ
				return TypeDescriptor.GetProperties(component, null)[valProp.Name];

			return null;
		}

		protected override void OnInit(EventArgs e) 
		{
			base.OnInit(e);
			//Page Validators Ӽ  ͸ ߰
			Page.Validators.Add(this);
		}        

		protected override void OnUnload(EventArgs e) 
		{
			if (Page != null) 
				//Page Validators Ӽ  ͸ 
				Page.Validators.Remove(this);

			base.OnUnload(e);
		}

		//ڽ Ʈѿ ؾϴ ߻ Ŭ
		protected abstract bool EvaluateIsValid();

		public void Validate() 
		{
			IsValid = EvaluateIsValid();
		}  
	}
}


