using System;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace CustomControls.TemplatedControls
{
	[ParseChildren(true)]
	public class ParseChildren : Control
	{
		ChildControl childOne;
		ChildControl childTwo;

		public ChildControl ChildOne {
			get {return childOne;}
			set {childOne = value;}
		}

		public ChildControl ChildTwo {
			get {return childTwo;}
			set {childTwo = value;}
		}

		protected override void Render(HtmlTextWriter writer)
		{
			if (childOne != null) 
				writer.Write("ChildOne : " + childOne.Message + "<hr>");
			if (childTwo != null) 
				writer.Write("ChildTwo : " + childTwo.Message + "<hr>");
		}

		public class ChildControl
		{
			private string message;

			public string Message {
				get {return message;}
				set {message = value;}
			}
		}
	}
}
