using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace CustomControls.Validators
{
	/// <summary>
	/// SimpleCustomValidator1   Դϴ.
	/// </summary>
	[
	ToolboxData("<{0}:SimpleCustomValidator2 runat=server ErrorMessage=\"SimpleCustomValidator1\"></{0}:SimpleCustomValidator2>")
	]
	public class SimpleCustomValidator2 : SimpleBaseValidator2
	{
		public event ServerValidateEventHandler ServerValidate;

		[
		Category("Behavior"),
		DefaultValue("")
		]
		public string ClientValidationFunction
		{
			get 
			{
				object o = ViewState["ClientValidationFunction"];
				return((o == null) ? String.Empty : (string)o);
			}
			set {ViewState["ClientValidationFunction"] = value;}
		}

		protected override void AddAttributesToRender(HtmlTextWriter writer)
		{
			base.AddAttributesToRender(writer);
			if (RenderUplevel) 
			{
				writer.AddAttribute("evaluationfunction", "CustomValidatorEvaluateIsValid");
				if (ClientValidationFunction.Length > 0) 
					writer.AddAttribute("clientvalidationfunction", ClientValidationFunction);
			}
		} 

		protected override bool EvaluateIsValid() 
		{
			string controlValue = GetControlValidationValue(ControlToValidate);
			if (controlValue == null)
				throw new Exception("ControlToValidate  Ʈѿ ȿ ˻縦   ϴ.");

			ServerValidateEventArgs eventArgs = new ServerValidateEventArgs(controlValue, this.IsValid);

			if (ServerValidate != null)
			{
				ServerValidate(this, eventArgs);
				return eventArgs.IsValid;
			}
			else
				return true;

		} 
	}
}
