using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using PowerOfDotNet.Components;

namespace PowerOfDotNet.NewStudy.Lacture
{
	/// <summary>
	/// LactureListEdit   Դϴ.
	/// </summary>
	public class LactureListEdit : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox txtSubject;
		protected System.Web.UI.WebControls.TextBox txtDBTable;
		protected System.Web.UI.WebControls.LinkButton lnkbtnUpdate;
		protected System.Web.UI.WebControls.HyperLink hyplnkCancel;
		protected System.Web.UI.WebControls.TextBox txtImagePath;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstType;
		protected System.Web.UI.WebControls.TextBox txtHtml;
		protected System.Web.UI.WebControls.CheckBoxList chkboxlstRoles;
		protected System.Web.UI.WebControls.TextBox txtListPage;
		protected System.Web.UI.WebControls.TextBox txtContetPage;
		protected System.Web.UI.WebControls.TextBox txtWritePage;
		protected System.Web.UI.WebControls.TextBox txtReplyPage;
		protected System.Web.UI.WebControls.TextBox txtEditPage;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstSubjectDiepMethod;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!this.IsPostBack)
			{
				hyplnkCancel.NavigateUrl = Request.UrlReferrer.ToString();
				int moduleId = Convert.ToInt32(Request.Params["moduleId"]);

				Hashtable moduleSettings = PortalSettings.GetModuleSettings(moduleId);
				int tableId;
				if (moduleSettings["TableID"] != null)
				{
					tableId = Convert.ToInt32( moduleSettings["TableID"] );
					BoardLactureDB db = new BoardLactureDB();
					BoardLactureInfo boardInfo = db.GetBoardInfo(tableId);
					txtDBTable.Text = boardInfo.BBSTable;
					txtSubject.Text = boardInfo.BBSSubject;
					txtHtml.Text = boardInfo.BBSHtml;
					txtImagePath.Text = boardInfo.BBSImage;
					rdobtnlstSubjectDiepMethod.SelectedIndex = boardInfo.BBSDisplayType;
					rdobtnlstType.SelectedIndex = boardInfo.BBSType;
					txtListPage.Text = boardInfo.BBSPageNameList;
					txtContetPage.Text = boardInfo.BBSPageNameContent;
					txtWritePage.Text = boardInfo.BBSPageNameWrite;
					txtEditPage.Text = boardInfo.BBSPageNameEdit;
					txtReplyPage.Text = boardInfo.BBSPageNameReply;
					
					PortalSettings portalSettings = (PortalSettings) Context.Items["PortalSettings"];
					AdminDB admin = new AdminDB();
					SqlDataReader roles = admin.GetPortalRoles(portalSettings.PortalId);

					// Clear existing items in checkboxlist
					chkboxlstRoles.Items.Clear();
					string[] aRoles = boardInfo.BBSRoles.Split(new char[] {';'});
					while(roles.Read()) 
					{
						ListItem item = new ListItem();
						item.Text = (String) roles["RoleName"];
						item.Value = roles["RoleID"].ToString();
            
						if (Array.IndexOf(aRoles, item.Text) > -1)
						{
							item.Selected = true;
						}

						chkboxlstRoles.Items.Add(item);
					}
				}
				else //ó ϴ 
					tableId = -1;

				ViewState["tableId"] = tableId;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.lnkbtnUpdate.Click += new System.EventHandler(this.LinkButton1_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void LinkButton1_Click(object sender, System.EventArgs e)
		{
			int tableId = Convert.ToInt32( ViewState["tableId"] );
			BoardLactureInfo boardInfo = new BoardLactureInfo();

			boardInfo.BBSID = tableId;
			boardInfo.BBSTable = txtDBTable.Text;
			boardInfo.BBSSubject = txtSubject.Text;
			boardInfo.BBSHtml = txtHtml.Text;
			boardInfo.BBSImage = txtImagePath.Text;
			boardInfo.BBSDisplayType = Convert.ToByte(rdobtnlstSubjectDiepMethod.SelectedIndex);
			boardInfo.BBSType = Convert.ToByte(rdobtnlstType.SelectedIndex);
			boardInfo.BBSImageHeadName = "";
			boardInfo.BBSCssClassHead = "";
			boardInfo.BBSMessage = "";
			boardInfo.BBSMsgContent = "";
			boardInfo.BBSPageNameList = txtListPage.Text;
			boardInfo.BBSPageNameContent = txtContetPage.Text;
			boardInfo.BBSPageNameWrite = txtWritePage.Text;
			boardInfo.BBSPageNameEdit = txtEditPage.Text;
			boardInfo.BBSPageNameReply = txtReplyPage.Text;

			String roles = "";
			foreach(ListItem item in chkboxlstRoles.Items) 
			{
				if (item.Selected == true) 
				{
					roles += item.Text + ";";
				}
			}
			boardInfo.BBSRoles = roles;

			BoardLactureDB db = new BoardLactureDB();
			int newTableId = db.UpdateBBSInfo(boardInfo);
			if (tableId == -1)
			{
				int moduleId = Convert.ToInt32(Request.Params["moduleId"]);
				AdminDB admin = new AdminDB();
				admin.UpdateModuleSetting(moduleId, "TableID", newTableId.ToString());
			}

			//⼭   ǵ
			// ĳø .
			this.Cache.Remove("__Obj_BoardLactureTableInfo" + newTableId);

			Response.Redirect(hyplnkCancel.NavigateUrl);
		}
	}
}
