using System;
using System.IO;
using System.Web;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace PowerOfDotNet.Components
{
	/// <summary>
	/// AvatarDB   Դϴ.
	/// </summary>
	public class AvatarDB
	{
		public SqlDataReader GetPositions()
		{
			string sql = "select PositionID, Description, ExclusiveCircumference from AvatarPositionDef";
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand getSubjectCmd = new SqlCommand(sql, myConnection);

			myConnection.Open();
			SqlDataReader dr = getSubjectCmd.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public SqlDataReader GetCategory()
		{
			string sql = "select ID, Subject from AvatarCategory";
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand getSubjectCmd = new SqlCommand(sql, myConnection);

			myConnection.Open();
			SqlDataReader dr = getSubjectCmd.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public int AddItem(string itemName, int positionId, ListItemCollection depPosIds, 
				int categoryId, int cost, string thumbnailImage,int sex, HtmlInputFile frontImage, int frontLayer, 
				HtmlInputFile backImage, int backLayer)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand itemCommand = new SqlCommand("UpdateAvatarItems", myConnection);

			itemCommand.CommandType = CommandType.StoredProcedure;

			itemCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;

			//߰  0   ش
			itemCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.Int, 4)).Value = -1;
			itemCommand.Parameters.Add(new SqlParameter("@ItemName", SqlDbType.NVarChar, 50)).Value = itemName;
			itemCommand.Parameters.Add(new SqlParameter("@PositionID", SqlDbType.Int)).Value = positionId;
			itemCommand.Parameters.Add(new SqlParameter("@CategoryID", SqlDbType.Int)).Value = categoryId;
			itemCommand.Parameters.Add(new SqlParameter("@Cost", SqlDbType.Money)).Value = cost;
			itemCommand.Parameters.Add(new SqlParameter("@Sex", SqlDbType.TinyInt)).Value = sex;
			itemCommand.Parameters.Add(new SqlParameter("@ThumbnailImage", SqlDbType.VarChar, 150)).Value = thumbnailImage;

			string sqlInsertAccessory = "insert into AvatarPositionMaps (PositionID, AccessoryID) ";
			sqlInsertAccessory += "VALUES (@PositionID, @AccessoryID)";
			SqlCommand insertAccessoryCommand = new SqlCommand(sqlInsertAccessory, myConnection);

			string sqlAvatarItemsImages = "INSERT INTO [AvatarItemImages] ";
			sqlAvatarItemsImages += "([ItemID], [LayerNum], [ImageName]) ";
			sqlAvatarItemsImages += "VALUES ";
			sqlAvatarItemsImages += "(@ItemID, @LayerNum, @ImageName)";
			SqlCommand avatarItemsImagesCommand = new SqlCommand(sqlAvatarItemsImages, myConnection);

			int retVar = 1;

			myConnection.Open();
			SqlTransaction stTrans = myConnection.BeginTransaction();
			//Ʈ
			itemCommand.Transaction = stTrans;
			insertAccessoryCommand.Transaction = stTrans;
			avatarItemsImagesCommand.Transaction = stTrans;

			try
			{
				itemCommand.ExecuteNonQuery();
				retVar = Convert.ToInt32(itemCommand.Parameters["RETURN_VALUE"].Value);

				foreach(ListItem item in depPosIds) 
				{
					if (item.Selected == true)
					{
						insertAccessoryCommand.Parameters.Clear();
						insertAccessoryCommand.Parameters.Add(
							new SqlParameter("@PositionID", SqlDbType.Int)).Value = retVar;
						insertAccessoryCommand.Parameters.Add(
							new SqlParameter("@AccessoryID", SqlDbType.Int)).Value = positionId;
						insertAccessoryCommand.ExecuteNonQuery();
					}
				}

				bool frontImageUploaded = (frontImage.PostedFile != null && 
									frontImage.PostedFile.FileName.Trim() != "");
				bool backImageUploaded = (backImage.PostedFile != null && 
									backImage.PostedFile.FileName.Trim() != "");
				string frontImageName = String.Empty;
				string backImageName = String.Empty;

				if (frontImageUploaded)
				{
					avatarItemsImagesCommand.Parameters.Add(
						new SqlParameter("@ItemID", SqlDbType.Int)).Value = retVar;
					//ǿ  ̾ Ѵ.
					int frontLlayerBase = positionId / 10 * 10; //1 ڸ ߶󳽴.
					avatarItemsImagesCommand.Parameters.Add(
						new SqlParameter("@LayerNum", SqlDbType.Int)).Value = frontLayer + frontLlayerBase;

					string posDir = "/Avatar/ImageSource/Pos" + frontLlayerBase;
					int fileNum = 1;
					
					while (true)
					{
						if (!File.Exists(HttpContext.Current.Server.MapPath(posDir + "/item" + fileNum + ".gif")))
						{
							frontImageName = posDir + "/item" + fileNum + ".gif";
							break;
						}
						fileNum++;
					}
					
					avatarItemsImagesCommand.Parameters.Add(
						new SqlParameter("@ImageName", SqlDbType.VarChar)).Value = frontImageName;
					avatarItemsImagesCommand.ExecuteNonQuery();
				}
				if (backImageUploaded)
				{
					avatarItemsImagesCommand.Parameters.Clear();
					avatarItemsImagesCommand.Parameters.Add(
						new SqlParameter("@ItemID", SqlDbType.Int)).Value = retVar;
					// ̾ 10 ڸ
					avatarItemsImagesCommand.Parameters.Add(
						new SqlParameter("@LayerNum", SqlDbType.Int)).Value = backLayer + 10;

					string posDir = "/Avatar/ImageSource/Pos10";
					int fileNum = 1;
					
					while (true)
					{
						if (!File.Exists(HttpContext.Current.Server.MapPath(posDir + "/item" + fileNum + ".gif")))
						{
							backImageName = posDir + "/item" + fileNum + ".gif";
							break;
						}
						fileNum++;
					}

					avatarItemsImagesCommand.Parameters.Add(
						new SqlParameter("@ImageName", SqlDbType.VarChar)).Value = backImageName;
					avatarItemsImagesCommand.ExecuteNonQuery();
				}

				// Ʈ ó ʵǱ⶧ 
				//  óѴ.
				if (frontImageUploaded)
				{
					frontImage.PostedFile.SaveAs(HttpContext.Current.Server.MapPath(frontImageName));
				}
				if (backImageUploaded)
				{
					backImage.PostedFile.SaveAs(HttpContext.Current.Server.MapPath(backImageName));
				}

				stTrans.Commit();
			}
			catch (Exception err)
			{
				string s = err.Message;
				retVar = -1;
				stTrans.Rollback();
			}
			finally
			{
				myConnection.Close();
			}

			return retVar;
		}


		public int UpdateItem(int id, string itemName, int positionId, ListItemCollection depPosIds, 
			int categoryId, int cost, int sex, string thumbnailImage, bool updateFront, HtmlInputFile frontImage, 
			int frontLayer, bool updateBack, HtmlInputFile backImage, int backLayer)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand itemCommand = new SqlCommand("UpdateAvatarItems", myConnection);

			itemCommand.CommandType = CommandType.StoredProcedure;

			itemCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;

			itemCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.Int, 4)).Value = id;
			itemCommand.Parameters.Add(new SqlParameter("@ItemName", SqlDbType.NVarChar, 50)).Value = itemName;
			itemCommand.Parameters.Add(new SqlParameter("@PositionID", SqlDbType.Int)).Value = positionId;
			itemCommand.Parameters.Add(new SqlParameter("@CategoryID", SqlDbType.Int)).Value = categoryId;
			itemCommand.Parameters.Add(new SqlParameter("@Cost", SqlDbType.Money)).Value = cost;
			itemCommand.Parameters.Add(new SqlParameter("@Sex", SqlDbType.TinyInt)).Value = sex;
			itemCommand.Parameters.Add(new SqlParameter("@ThumbnailImage", SqlDbType.VarChar, 150)).Value = thumbnailImage;

			string sqlDeleteAccessory = "delete from AvatarPositionMaps where AccessoryID=@AccessoryID";
			SqlCommand deleteAccessoryCommand = new SqlCommand(sqlDeleteAccessory, myConnection);

			deleteAccessoryCommand.Parameters.Add(new SqlParameter("@AccessoryID", SqlDbType.Int, 4)).Value = id;

			string sqlInsertAccessory = "insert into AvatarPositionMaps (PositionID, AccessoryID) ";
			sqlInsertAccessory += "VALUES (@PositionID, @AccessoryID)";
			SqlCommand insertAccessoryCommand = new SqlCommand(sqlInsertAccessory, myConnection);

			// ̹ ̸  
			string sqlGetOldImageNames = "select ImageName, LayerNum from AvatarItemImages where ItemID=" + id;
			SqlCommand getOldImageNamesCommand = new SqlCommand(sqlGetOldImageNames, myConnection);
			string oldFrontImage = String.Empty;
			string oldBackImage = String.Empty;

			// ̹ ſ 
			string sqlDeleteImages = String.Empty;
			if (updateFront && updateBack)
				sqlDeleteImages = "delete from AvatarItemImages where ItemID=@ItemID";
			else if (updateBack)
				sqlDeleteImages = "delete from AvatarItemImages where ItemID=@ItemID and LayerNum>=20 and LayerNum<30";
			else if (updateFront)
				sqlDeleteImages = "delete from AvatarItemImages where ItemID=@ItemID and not(LayerNum>=20 and LayerNum<30)";
			SqlCommand deleteImagesCommand = new SqlCommand(sqlDeleteImages, myConnection);

			//updateFront updateBack äũ  μƮ Ѵ.
			string sqlAvatarItemsImages = "INSERT INTO [AvatarItemImages] ";
			sqlAvatarItemsImages += "([ItemID], [LayerNum], [ImageName]) ";
			sqlAvatarItemsImages += "VALUES ";
			sqlAvatarItemsImages += "(@ItemID, @LayerNum, @ImageName)";
			SqlCommand avatarItemsImagesCommand = new SqlCommand(sqlAvatarItemsImages, myConnection);

			int retVar = 1;

			myConnection.Open();
			// ̹  о´.
			SqlDataReader drOldImages = getOldImageNamesCommand.ExecuteReader();
			while (drOldImages.Read())
			{
				int layerNum = (int)drOldImages["LayerNum"];
				if (layerNum >= 20 && layerNum < 30)
					oldBackImage = drOldImages["ImageName"].ToString();
				else
					oldFrontImage = drOldImages["ImageName"].ToString();
			}
			drOldImages.Close();

			SqlTransaction stTrans = myConnection.BeginTransaction();
			//Ʈ
			itemCommand.Transaction = stTrans;
			insertAccessoryCommand.Transaction = stTrans;
			avatarItemsImagesCommand.Transaction = stTrans;
			deleteImagesCommand.Transaction = stTrans;
			deleteAccessoryCommand.Transaction = stTrans;

			try
			{
				itemCommand.ExecuteNonQuery();
				deleteAccessoryCommand.ExecuteNonQuery();

				foreach(ListItem item in depPosIds) 
				{
					if (item.Selected == true)
					{
						insertAccessoryCommand.Parameters.Clear();
						insertAccessoryCommand.Parameters.Add(
							new SqlParameter("@PositionID", SqlDbType.Int)).Value = int.Parse(item.Value);
						insertAccessoryCommand.Parameters.Add(
							new SqlParameter("@AccessoryID", SqlDbType.Int)).Value = id;
						insertAccessoryCommand.ExecuteNonQuery();
					}
				}

				// ̹  
				if ((oldFrontImage != String.Empty || oldBackImage != String.Empty) && sqlDeleteImages != String.Empty)
					deleteImagesCommand.ExecuteNonQuery();
				
				bool frontImageUploaded = (frontImage.PostedFile != null && 
					frontImage.PostedFile.FileName.Trim() != "");
				bool backImageUploaded = (backImage.PostedFile != null && 
					backImage.PostedFile.FileName.Trim() != "");
				string frontImageName = String.Empty;
				string backImageName = String.Empty;

				//Ʈ äũǾ ε   ߰ ʴ´.
				if (updateFront && frontImageUploaded)
				{
					avatarItemsImagesCommand.Parameters.Add(
						new SqlParameter("@ItemID", SqlDbType.Int)).Value = id;
					//ǿ  ̾ Ѵ.
					int frontLlayerBase = positionId / 10 * 10; //1 ڸ ߶󳽴.
					avatarItemsImagesCommand.Parameters.Add(
						new SqlParameter("@LayerNum", SqlDbType.Int)).Value = frontLayer + frontLlayerBase;

					// ̹ ־  ̸ ״ ϰ
					//ƴϸ  ̸ Ѵ.
					if (oldFrontImage == String.Empty)
					{
						string posDir = "/Avatar/ImageSource/Pos" + frontLlayerBase;
						int fileNum = 1;
					
						while (true)
						{
							if (!File.Exists(HttpContext.Current.Server.MapPath(posDir + "/item" + fileNum + ".gif")))
							{
								frontImageName = posDir + "/item" + fileNum + ".gif";
								break;
							}
							fileNum++;
						}
					}
					else
					{
						frontImageName = oldFrontImage;
					}
					
					avatarItemsImagesCommand.Parameters.Add(
						new SqlParameter("@ImageName", SqlDbType.VarChar)).Value = frontImageName;
					avatarItemsImagesCommand.ExecuteNonQuery();
				}
				//Ʈ äũǾ ε   ߰ ʴ´.
				if (updateBack && backImageUploaded)
				{
					avatarItemsImagesCommand.Parameters.Clear();
					avatarItemsImagesCommand.Parameters.Add(
						new SqlParameter("@ItemID", SqlDbType.Int)).Value = id;
					// ̾ 10 ڸ
					avatarItemsImagesCommand.Parameters.Add(
						new SqlParameter("@LayerNum", SqlDbType.Int)).Value = backLayer + 10;

					// ̹ ־  ̸ ״ ϰ
					//ƴϸ  ̸ Ѵ.
					if (oldBackImage == String.Empty)
					{
						string posDir = "/Avatar/ImageSource/Pos10";
						int fileNum = 1;
					
						while (true)
						{
							if (!File.Exists(HttpContext.Current.Server.MapPath(posDir + "/item" + fileNum + ".gif")))
							{
								backImageName = posDir + "/item" + fileNum + ".gif";
								break;
							}
							fileNum++;
						}
					}
					else
					{
						backImageName = oldBackImage;
					}

					avatarItemsImagesCommand.Parameters.Add(
						new SqlParameter("@ImageName", SqlDbType.VarChar)).Value = backImageName;
					avatarItemsImagesCommand.ExecuteNonQuery();
				}

				// Ʈ ó ʵǱ⶧ 
				//  óѴ.
				if (oldFrontImage != String.Empty && File.Exists(HttpContext.Current.Server.MapPath(oldFrontImage)))
					File.Delete(HttpContext.Current.Server.MapPath(oldFrontImage));
				if (oldBackImage != String.Empty && File.Exists(HttpContext.Current.Server.MapPath(oldBackImage)))
					File.Delete(HttpContext.Current.Server.MapPath(oldBackImage));

				if (updateFront && frontImageUploaded)
				{
					frontImage.PostedFile.SaveAs(HttpContext.Current.Server.MapPath(frontImageName));
				}
				if (updateBack && backImageUploaded)
				{
					backImage.PostedFile.SaveAs(HttpContext.Current.Server.MapPath(backImageName));
				}

				stTrans.Commit();
			}
			catch (Exception err)
			{
				string s = err.Message;
				retVar = -1;
				stTrans.Rollback();
			}
			finally
			{
				myConnection.Close();
			}

			return retVar;
		}

		public int DeleteItem(int id)
		{
			string sqlDeleteItem = "delete from AvatarItems where ID=@ID";
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand itemDeleteCommand = new SqlCommand(sqlDeleteItem, myConnection);

			itemDeleteCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.Int, 4)).Value = id;

			string sqlDeleteAccessory = "delete from AvatarPositionMaps where AccessoryID=" + id;
			SqlCommand deleteAccessoryCommand = new SqlCommand(sqlDeleteAccessory, myConnection);

			// ̹ ̸  
			string sqlGetOldImageNames = "select ImageName, LayerNum from AvatarItemImages where ItemID=" + id;
			SqlCommand getOldImageNamesCommand = new SqlCommand(sqlGetOldImageNames, myConnection);
			string oldFrontImage = String.Empty;
			string oldBackImage = String.Empty;

			// ̹ ſ 
			string sqlDeleteImages = "delete from AvatarItemImages where ItemID=" + id;
			SqlCommand deleteImagesCommand = new SqlCommand(sqlDeleteImages, myConnection);

			myConnection.Open();
			// ̹  о´.
			SqlDataReader drOldImages = getOldImageNamesCommand.ExecuteReader();
			while (drOldImages.Read())
			{
				int layerNum = (int)drOldImages["LayerNum"];
				if (layerNum >= 20 && layerNum < 30)
					oldBackImage = drOldImages["ImageName"].ToString();
				else
					oldFrontImage = drOldImages["ImageName"].ToString();
			}
			drOldImages.Close();

			SqlTransaction stTrans = myConnection.BeginTransaction();
			//Ʈ
			itemDeleteCommand.Transaction = stTrans;
			deleteImagesCommand.Transaction = stTrans;
			deleteAccessoryCommand.Transaction = stTrans;

			int retVar = 1;
			try
			{
				deleteImagesCommand.ExecuteNonQuery();
				deleteAccessoryCommand.ExecuteNonQuery();

				itemDeleteCommand.ExecuteNonQuery();

				// Ʈ ó ʵǱ⶧ 
				//  óѴ.
				if (oldFrontImage != String.Empty && File.Exists(HttpContext.Current.Server.MapPath(oldFrontImage)))
					File.Delete(HttpContext.Current.Server.MapPath(oldFrontImage));
				if (oldBackImage != String.Empty && File.Exists(HttpContext.Current.Server.MapPath(oldBackImage)))
					File.Delete(HttpContext.Current.Server.MapPath(oldBackImage));

				stTrans.Commit();
			}
			catch (Exception err)
			{
				string s = err.Message;
				retVar = -1;
				stTrans.Rollback();
			}
			finally
			{
				myConnection.Close();
			}

			return retVar;
		}

		public SqlDataReader GetItems(string orderBy)
		{
			string sql = "select * from AvatarItems";
			if (orderBy != String.Empty)
				sql += " order by " + orderBy;
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand getSubjectCmd = new SqlCommand(sql, myConnection);

			myConnection.Open();
			SqlDataReader dr = getSubjectCmd.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public SqlDataReader GetItemsWhereCategory(int categoryId)
		{
			string sql = "select * from AvatarItems where CategoryID=" + categoryId;
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand getSubjectCmd = new SqlCommand(sql, myConnection);

			myConnection.Open();
			SqlDataReader dr = getSubjectCmd.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public DataSet GetAllItems()
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);

			string sql = "select * from AvatarItems";
			SqlDataAdapter sda = new SqlDataAdapter(sql, myConnection);
			DataSet ds = new DataSet();
			sda.Fill(ds, "AvatarItems");
			sda.SelectCommand.CommandText = "select * from AvatarItemImages";
			sda.Fill(ds, "AvatarItemImages");

			ds.Tables[0].TableName = "AvatarItems";
			ds.Tables[1].TableName = "AvatarItemImages";
			
			return ds;
		}

		//ǿ  ׼ Ѵ.
		public SqlDataReader GetPositionAction(int id)
		{
			string sql = "select * from AvatarPositionAction where PositionID=" + id;
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand(sql, myConnection);

			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		//id ӵǾִ   Ѵ
		public SqlDataReader GetDependedPositions(int id)
		{
			string sql = "select PositionID from AvatarPositionMaps where AccessoryID=" + id;
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand(sql, myConnection);

			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		//id ӵ  Ѵ.
		public SqlDataReader GetDependPositions(int id)
		{
			string sql = "select AccessoryID from AvatarPositionMaps where PositionID=" + id;
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand(sql, myConnection);

			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public SqlDataReader GetItemImages(int id)
		{
			string sql = "select LayerNum, ImageName from AvatarItemImages where ItemID=" + id;
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand(sql, myConnection);

			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public SqlDataReader GetUserItems(string userId)
		{
			string sql = "select UserID, ItemID from UserAvatar where UserID=@UserID";
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand(sql, myConnection);

			myCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.VarChar, 12)).Value = userId;

			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public void DeleteUserItems(string userId)
		{
			string sql = "delete from UserAvatar where UserID=@UserID";
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand(sql, myConnection);

			myCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.VarChar, 12)).Value = userId;

			myConnection.Open();
			myCommand.ExecuteNonQuery();
			myConnection.Close();
		}

		public void InsertUserItem(string userId, string id)
		{
			string sql = "insert into UserAvatar (UserID, ItemID) values(@UserID, @ItemID)";
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand(sql, myConnection);

			myCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.VarChar, 12)).Value = userId;
			myCommand.Parameters.Add(new SqlParameter("@ItemID", SqlDbType.Int)).Value = id;

			myConnection.Open();
			myCommand.ExecuteNonQuery();
			myConnection.Close();
		}

		public SqlDataReader GetUserAvater(string userId)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("GetUserAvatar", myConnection);
			
			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.VarChar, 12)).Value = userId;

			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public SqlDataReader GetDefaultAvatar()
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("GetDefaultAvatar", myConnection);
			
			myCommand.CommandType = CommandType.StoredProcedure;

			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public SqlDataReader GetAvatarExpression()
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("GetAvatarExpression", myConnection);
			
			myCommand.CommandType = CommandType.StoredProcedure;

			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public SqlDataReader GetAvatarExpressionItem(int id)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("GetAvatarExpressionItem", myConnection);
			
			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@ID", SqlDbType.Int)).Value = id;

			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

	}
}
