namespace PowerOfDotNet.NewStudy.Lacture
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Collections;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using MyWebLibs.Utilities;

	/// <summary>
	///		ContentBody   Դϴ.
	/// </summary>
	public abstract class ContentBody : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.DataList BodyList;
		protected System.Web.UI.WebControls.Panel pnlHeader;

		private PowerOfDotNet.Components.BoardLactureInfo _blInfo;
		private ArrayList _parsedParams;

		private void Page_Load(object sender, System.EventArgs e)
		{
			//  ´.
			int boardId = CommonMethods.RequestInt(Request.Params["TableId"], -1);

			//ɽÿ   ´.
			_blInfo = (PowerOfDotNet.Components.BoardLactureInfo)this.GetObjectFromCache("BoardLactureTableInfo" + boardId);
			if (_blInfo == null) {
				PowerOfDotNet.Components.BoardLactureDB db = new PowerOfDotNet.Components.BoardLactureDB();
				_blInfo = db.GetBoardInfo(boardId);

				this.SetObjectToCache("BoardLactureTableInfo" + boardId, _blInfo, 30);
			}

			pnlHeader.Style["text-align"] = "center";
			//ŸƲ 
			switch (_blInfo.BBSDisplayType)	{
				case 0 :
					pnlHeader.Controls.Add(new LiteralControl(_blInfo.BBSSubject));
					pnlHeader.Style["font-size"] = "16px";
					pnlHeader.Style["font-weight"] = "bold";
					break;
				case 1 :
					pnlHeader.Controls.Add(new LiteralControl("<img src='" + _blInfo.BBSImage + "' />"));
					break;
				case 2 :
					pnlHeader.Controls.Add(new LiteralControl(_blInfo.BBSHtml));
					break;
			}

			if (!IsPostBack) {
				ArrayList groupKeys = new ArrayList();
				//group<n> Ķ Ű  groupKeys Ѵ.
				foreach (string key in Request.QueryString.AllKeys) {
					if (key != null && key.StartsWith("group"))
						groupKeys.Add(key);
				}
				
				_parsedParams = new ArrayList();
				string groupParam;
				foreach (string key in groupKeys) {
					groupParam = Request.QueryString[key];
					//aG[0] == GroupID
					//aG[1] == ID1,ID2,...
					string[] aG = groupParam.Split(new Char[] {':'});
					if (aG.Length != 2)
						throw new Exception(key + "  ùٸ ʽϴ.");

					string[] aP = aG[1].Split(new Char[] {','});
					if (aG.Length < 1)
						throw new Exception(key + "  ùٸ ʽϴ.");

					//GroupID ID ä 
					GroupInfo mg = new GroupInfo(Convert.ToInt32(aG[0]), Convert.ToInt32(aP[0]));
					//ID  
					for (int i=1; i<aP.Length; i++)
						mg.AddId(Convert.ToInt32(aP[i]));

					_parsedParams.Add(mg);
				}

				/*
				//  뺸⿡ Խù  Ҷ
				//   ִ.
				int num = 0;
				while ((groupParam = Request.QueryString["group" + num.ToString()]) != null)
				{
					//aG[0] == GroupID
					//aG[1] == ID1,ID2,...
					string[] aG = groupParam.Split(new Char[] {':'});
					if (aG.Length != 2)
						throw new Exception("group" + num.ToString() + "  ùٸ ʽϴ.");

					string[] aP = aG[1].Split(new Char[] {','});
					if (aG.Length < 1)
						throw new Exception("group" + num.ToString() + "  ùٸ ʽϴ.");

					//GroupID ID ä 
					GroupInfo mg = new GroupInfo(Convert.ToInt32(aG[0]), Convert.ToInt32(aP[0]));
					//ID  
					for (int i=1; i<aP.Length; i++)
						mg.AddPid(Convert.ToInt32(aP[i]));

					_parsedParams.Add(mg);
					num++;
				}
				*/
				ViewState["parsedParams"] = _parsedParams;
			}
			else {
				_parsedParams = (ArrayList)ViewState["parsedParams"];
			}
			BodyList.DataSource = _parsedParams;
			BodyList.DataBind();

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.BodyList.PreRender += new System.EventHandler(this.BodyList_PreRender);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void BodyList_PreRender(object sender, System.EventArgs e)
		{
			//ȸ 
			this.Session["LactureForVistedIncrease"] = Request.RawUrl;
		}
	}

	//ڽ Ʈѵ鿡  ü ͸ ׼ Ѵ.
	[Serializable]
	public sealed class GroupInfo
	{
		private int _groupId;
		private ArrayList _ids;

		public int Count {
			get {return _ids.Count;}
		}

		public ArrayList IDs {
			get {return _ids;}
		}

		public int GroupID {
			get {return _groupId;}
		}

		public GroupInfo(int groupId, int id)
		{
			_groupId = groupId;
			_ids = new ArrayList();
			_ids.Add(id);
		}
		public void AddId(int id)
		{
			_ids.Add(id);
		}
	}
}
