/*
 * 2003 11 1 
 * */

using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;
using MyWebLibs.Utilities;

namespace MyWebLibs.ServerControls
{
	[ToolboxData("<{0}:RollOverHyperLink runat=server></{0}:RollOverHyperLink>")]
	public class RollOverHyperLink : HyperLink
	{
		private string _ImageUrlOver = String.Empty;
		private bool _RoolOver = true;
		private bool isRuntime = false;

		private const string ImagePreloadScript = @"
<script language=""javascript"">
<!--
function __preloadImages(a) {
	var d=document; 

  	if(!d.MM_p) d.MM_p=new Array();
	var i;
	var j=d.MM_p.length;
	
	for(i=0; i<a.length; i++){
		d.MM_p[j]=new Image; 
		d.MM_p[j++].src=a[i];
	}
}

if(typeof(aPreloadIMages) != ""undefined"")
{
	__preloadImages(aPreloadIMages);
}
//-->
</script>
		";

private const string setHyplinkImageScript = @"
<SCRIPT LANGUAGE=""JavaScript"">
<!--
function __setHyplinkImage(parentObj, image)
{
	var oChildren = parentObj.children;
	for(i=0;i<oChildren.length;i++)	{
		var childObj = oChildren.item(i);
		if (childObj.tagName == ""IMG"") {
			childObj.src = image;
		}
	}
}
//-->
</SCRIPT>
	";

		[Editor("System.Web.UI.Design.ImageUrlEditor, System.Design","System.Drawing.Design.UITypeEditor"),
		Category("Appearance"),
		Description("ѿ ̹.")]
		public string ImageUrlOver {
			get	{return _ImageUrlOver;}
			set	{_ImageUrlOver = value;}
		}

		[Category("Behavior"),
		DefaultValue(true),
		Description("ѿ .")]
		public bool RollOver {
			get	{return _RoolOver;}
			set	{_RoolOver = value;}
		}

		override protected void OnPreRender(EventArgs e) 
		{
			base.OnPreRender(e);

			isRuntime = true;
			if (CanRollOver() && DetermineRenderUplevel()) {
				//aPreloadIMages 迭 ѿ ̹ ̸ ߰Ѵ.
				Page.RegisterArrayDeclaration("aPreloadIMages", "\""+ CommonMethods.RealImagePath(_ImageUrlOver) + "\"");
				if (!Page.IsStartupScriptRegistered("ImagePreloadScript"))
					Page.RegisterStartupScript("ImagePreloadScript", ImagePreloadScript);
				if (!Page.IsStartupScriptRegistered("setHyplinkImageScript"))
					Page.RegisterStartupScript("setHyplinkImageScript", setHyplinkImageScript);
			}
		}

		protected override void AddAttributesToRender(HtmlTextWriter writer) 
		{
			base.AddAttributesToRender(writer);   

			if (CanRollOver() && DetermineRenderUplevel()) {
				writer.AddAttribute("onMouseOver", "__setHyplinkImage(this,'" + CommonMethods.RealImagePath(_ImageUrlOver) + "');");
				writer.AddAttribute("onMouseOut", "__setHyplinkImage(this,'" + CommonMethods.RealImagePath(ImageUrl) + "');");
			}
		}

		private bool CanRollOver()
		{
			return _RoolOver && 
				!_ImageUrlOver.Equals(String.Empty) && 
				!ImageUrl.Equals(String.Empty);
		}

		protected virtual bool DetermineRenderUplevel() 
		{
			if (!isRuntime) return false;

			Page page = Page;
			return (page.Request.Browser.W3CDomVersion.Major >= 1
				&& page.Request.Browser.EcmaScriptVersion.CompareTo(new Version(1, 2)) >= 0);
		}
	}
}