using System;
using System.Web;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.IO;

namespace PowerOfDotNet.Components
{
	public class BoardData
	{
		public int PID;
		public string Subject;
		public string Writer;
		public string Email;
		public string Content;
		public string Password;
		public string UserIP;
		public string UserID;
		public byte Format;
	}

	/// <summary>
	/// Summary description for BoardDB.
	/// </summary>
	public class BoardDB
	{
		public BoardDB()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public SqlDataReader GetList(int intPage, int intRowCount, int intTableID)
		{

			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("SP_BOARD_LIST", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@PAGE", SqlDbType.Int, 4)).Value = intPage;
			myCommand.Parameters.Add(new SqlParameter("@ROW_COUNT", SqlDbType.Int, 4)).Value = intRowCount;
			myCommand.Parameters.Add(new SqlParameter("@TABLEID", SqlDbType.Int, 4)).Value = intTableID;

			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public SqlDataReader GetContent(int intPID, int intTableID)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("SP_GET_CONTENT", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@PID", SqlDbType.Int, 4)).Value = intPID;
			myCommand.Parameters.Add(new SqlParameter("@TABLEID", SqlDbType.Int, 4)).Value = intTableID;

			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		public int DeleteOne(int intPID, int intTableID, string sPassword)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("SP_DELETE_ONE", myConnection);
			SqlCommand bbsTableName = new SqlCommand("SP_GET_TABLENAME", myConnection);

			bbsTableName.CommandType = CommandType.StoredProcedure;
			bbsTableName.Parameters.Add(new SqlParameter("@BBSID", SqlDbType.Int, 4)).Value = intTableID;
			SqlParameter paraTableName = new SqlParameter("@TABLENAME", SqlDbType.VarChar, 30);
			paraTableName.Direction = ParameterDirection.Output;
			bbsTableName.Parameters.Add(paraTableName);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;
			myCommand.Parameters.Add(new SqlParameter("@PID", SqlDbType.Int, 4)).Value = intPID;
			myCommand.Parameters.Add(new SqlParameter("@TABLEID", SqlDbType.Int, 4)).Value = intTableID;
			myCommand.Parameters.Add(new SqlParameter("@PASSWORD", SqlDbType.VarChar, 20)).Value = sPassword;

			myConnection.Open();
			bbsTableName.ExecuteNonQuery();

			string strTableName = paraTableName.Value.ToString();
			string sqlDeleteFile = "delete from " + strTableName + "Files where bfPID=@PID";

			SqlCommand bbsFileDeleteCommand = new SqlCommand(sqlDeleteFile, myConnection);

			bbsFileDeleteCommand.Parameters.Add(new SqlParameter("@PID", SqlDbType.Int, 4)).Value = intPID;
			
			SqlTransaction stTrans = myConnection.BeginTransaction();
			//Ʈ
			myCommand.Transaction = stTrans;
			bbsFileDeleteCommand.Transaction = stTrans;

			try
			{
				myCommand.ExecuteNonQuery();
				// ϵ .
				bbsFileDeleteCommand.ExecuteNonQuery();
				
				stTrans.Commit();
			}
			catch(Exception e) 
			{
				string s = e.Message;
				stTrans.Rollback();
			}
			finally
			{
				myConnection.Close();
			}

			return Convert.ToInt32(myCommand.Parameters["RETURN_VALUE"].Value);
		}

		public int EditOne(int intPID, int intTableID, string sPassword)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("SP_CHECK_PASSWORD", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;
			myCommand.Parameters.Add(new SqlParameter("@PID", SqlDbType.Int, 4)).Value = intPID;
			myCommand.Parameters.Add(new SqlParameter("@TABLEID", SqlDbType.Int, 4)).Value = intTableID;
			myCommand.Parameters.Add(new SqlParameter("@PASSWORD", SqlDbType.VarChar, 20)).Value = sPassword;

			myConnection.Open();
			myCommand.ExecuteNonQuery();
			myConnection.Close();

			return Convert.ToInt32(myCommand.Parameters["RETURN_VALUE"].Value);

		}

		public void Modify(BoardData oData, HttpFileCollection UploadFiles, int intTableID, bool bPreserve)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand bbsTableName = new SqlCommand("SP_GET_TABLENAME", myConnection);
			SqlCommand bbsCommand = new SqlCommand("SP_MODIFY_ROW", myConnection);

			bbsTableName.CommandType = CommandType.StoredProcedure;
			bbsTableName.Parameters.Add(new SqlParameter("@BBSID", SqlDbType.Int, 4)).Value = intTableID;
			SqlParameter paraTableName = new SqlParameter("@TABLENAME", SqlDbType.VarChar, 30);
			paraTableName.Direction = ParameterDirection.Output;
			bbsTableName.Parameters.Add(paraTableName);

			bbsCommand.CommandType = CommandType.StoredProcedure;
			bbsCommand.Parameters.Add(new SqlParameter("@PID", SqlDbType.Int, 4)).Value = oData.PID;
			bbsCommand.Parameters.Add(new SqlParameter("@TABLEID", SqlDbType.Int, 4)).Value = intTableID;
			bbsCommand.Parameters.Add(new SqlParameter("@SUBJECT", SqlDbType.VarChar, 100)).Value = oData.Subject;
			bbsCommand.Parameters.Add(new SqlParameter("@WRITER", SqlDbType.VarChar, 20)).Value = oData.Writer;
			bbsCommand.Parameters.Add(new SqlParameter("@EMAIL", SqlDbType.VarChar, 40)).Value = oData.Email;
			bbsCommand.Parameters.Add(new SqlParameter("@CONTENT", SqlDbType.Text)).Value = oData.Content;
			bbsCommand.Parameters.Add(new SqlParameter("@PASSWORD", SqlDbType.VarChar, 12)).Value = oData.Password;
			bbsCommand.Parameters.Add(new SqlParameter("@USERIP", SqlDbType.VarChar, 20)).Value = oData.UserIP;
			bbsCommand.Parameters.Add(new SqlParameter("@FORMAT", SqlDbType.TinyInt, 1)).Value = oData.Format;

			myConnection.Open();

			bbsTableName.ExecuteNonQuery();
			string strTableName = paraTableName.Value.ToString();
			string sqlDeleteFile = "delete from " + strTableName + "Files where bfPID=@PID";
			string sqlInsertFile = "insert into " + strTableName + "Files (bfPID,bfFileName,bfSize,bfContent) ";
			sqlInsertFile += "VALUES (@PID, @FileName, @Size, @Content)";

			SqlCommand bbsFileDeleteCommand = new SqlCommand(sqlDeleteFile, myConnection);
			SqlCommand bbsFileInsertCommand = new SqlCommand(sqlInsertFile, myConnection);

			SqlTransaction stTrans = myConnection.BeginTransaction();
			//Ʈ
			bbsCommand.Transaction = stTrans;
			bbsFileInsertCommand.Transaction = stTrans;
			bbsFileDeleteCommand.Transaction = stTrans;

			try
			{
				bbsCommand.ExecuteNonQuery();
				if (!bPreserve)
				{// ϵ .
					bbsFileDeleteCommand.Parameters.Add(new SqlParameter("@PID", SqlDbType.Int, 4)).Value = oData.PID;
					bbsFileDeleteCommand.ExecuteNonQuery();
				}

				for ( int intFileIndex = 0; intFileIndex < UploadFiles.Count; intFileIndex++ )
				{
					HttpPostedFile _postedFile = UploadFiles[intFileIndex]; 
					String strFileName = Path.GetFileName(_postedFile.FileName);

					if (strFileName == "") continue;

					int intSize = _postedFile.ContentLength;
					System.Byte[] FileByteArray = new System.Byte[intSize];
					Stream StreamObj = _postedFile.InputStream;
					StreamObj.Read(FileByteArray,0,intSize);

					bbsFileInsertCommand.Parameters.Clear();
					bbsFileInsertCommand.Parameters.Add(new SqlParameter("@PID", SqlDbType.Int, 4)).Value = oData.PID;
					bbsFileInsertCommand.Parameters.Add(new SqlParameter("@FileName", SqlDbType.Char, 30)).Value = strFileName;
					bbsFileInsertCommand.Parameters.Add(new SqlParameter("@Size", SqlDbType.BigInt)).Value = intSize;
					bbsFileInsertCommand.Parameters.Add(new SqlParameter("@Content", SqlDbType.Image)).Value = FileByteArray;

					bbsFileInsertCommand.ExecuteNonQuery();
				}
				stTrans.Commit();
			}
			catch(Exception e) 
			{
				string s = e.Message;
				stTrans.Rollback();
			}
			finally
			{
				myConnection.Close();
			}
		}

		public int InsertReply(BoardData oData, HttpFileCollection UploadFiles, int intTableID)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand bbsTableName = new SqlCommand("SP_GET_TABLENAME", myConnection);
			SqlCommand bbsCommand = new SqlCommand("SP_INSERT_REPLY_ROW", myConnection);

			bbsTableName.CommandType = CommandType.StoredProcedure;
			bbsTableName.Parameters.Add(new SqlParameter("@BBSID", SqlDbType.Int, 4)).Value = intTableID;
			SqlParameter paraTableName = new SqlParameter("@TABLENAME", SqlDbType.VarChar, 30);
			paraTableName.Direction = ParameterDirection.Output;
			bbsTableName.Parameters.Add(paraTableName);

			bbsCommand.CommandType = CommandType.StoredProcedure;
			bbsCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;
			bbsCommand.Parameters.Add(new SqlParameter("@PID", SqlDbType.Int, 4)).Value = oData.PID;
			bbsCommand.Parameters.Add(new SqlParameter("@TABLEID", SqlDbType.Int, 4)).Value = intTableID;
			bbsCommand.Parameters.Add(new SqlParameter("@SUBJECT", SqlDbType.VarChar, 100)).Value = oData.Subject;
			bbsCommand.Parameters.Add(new SqlParameter("@WRITER", SqlDbType.VarChar, 20)).Value = oData.Writer;
			bbsCommand.Parameters.Add(new SqlParameter("@EMAIL", SqlDbType.VarChar, 40)).Value = oData.Email;
			bbsCommand.Parameters.Add(new SqlParameter("@CONTENT", SqlDbType.Text)).Value = oData.Content;
			bbsCommand.Parameters.Add(new SqlParameter("@PASSWORD", SqlDbType.VarChar, 12)).Value = oData.Password;
			bbsCommand.Parameters.Add(new SqlParameter("@USERIP", SqlDbType.VarChar, 20)).Value = oData.UserIP;
			bbsCommand.Parameters.Add(new SqlParameter("@FORMAT", SqlDbType.TinyInt, 1)).Value = oData.Format;

			myConnection.Open();

			bbsTableName.ExecuteNonQuery();
			string strTableName = paraTableName.Value.ToString();
			string sqlInsertFile = "insert into " + strTableName + "Files (bfPID,bfFileName,bfSize,bfContent) ";
			sqlInsertFile += "VALUES (@PID, @FileName, @Size, @Content)";

			SqlCommand bbsFileCommand = new SqlCommand(sqlInsertFile, myConnection);

			SqlTransaction stTrans = myConnection.BeginTransaction();
			//Ʈ
			bbsCommand.Transaction = stTrans;
			bbsFileCommand.Transaction = stTrans;

			try
			{
				bbsCommand.ExecuteNonQuery();

				for ( int intFileIndex = 0; intFileIndex < UploadFiles.Count; intFileIndex++ ) 
				{
					HttpPostedFile _postedFile = UploadFiles[intFileIndex]; 
					String strFileName = Path.GetFileName(_postedFile.FileName);

					if (strFileName == "") continue;

					int intSize = _postedFile.ContentLength;
					System.Byte[] FileByteArray = new System.Byte[intSize];
					Stream StreamObj = _postedFile.InputStream;
					StreamObj.Read(FileByteArray,0,intSize);

					bbsFileCommand.Parameters.Clear();
					bbsFileCommand.Parameters.Add(new SqlParameter("@PID", SqlDbType.Int, 4)).Value = Convert.ToInt32(bbsCommand.Parameters["RETURN_VALUE"].Value);
					bbsFileCommand.Parameters.Add(new SqlParameter("@FileName", SqlDbType.Char, 30)).Value = strFileName;
					bbsFileCommand.Parameters.Add(new SqlParameter("@Size", SqlDbType.BigInt)).Value = intSize;
					bbsFileCommand.Parameters.Add(new SqlParameter("@Content", SqlDbType.Image)).Value = FileByteArray;

					bbsFileCommand.ExecuteNonQuery();
				}
				stTrans.Commit();
			}
			catch(Exception e) 
			{
				string s = e.Message;
				stTrans.Rollback();
			}
			finally
			{
				myConnection.Close();
			}
			return Convert.ToInt32(bbsCommand.Parameters["RETURN_VALUE"].Value);
		}

		public void AddNew(BoardData oData, HttpFileCollection UploadFiles, int intTableID)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand bbsTableName = new SqlCommand("SP_GET_TABLENAME", myConnection);
			SqlCommand bbsCommand = new SqlCommand("SP_ADD_ROW", myConnection);

			bbsTableName.CommandType = CommandType.StoredProcedure;
			bbsTableName.Parameters.Add(new SqlParameter("@BBSID", SqlDbType.Int, 4)).Value = intTableID;
			SqlParameter paraTableName = new SqlParameter("@TABLENAME", SqlDbType.VarChar, 30);
			paraTableName.Direction = ParameterDirection.Output;
			bbsTableName.Parameters.Add(paraTableName);

			bbsCommand.CommandType = CommandType.StoredProcedure;
			bbsCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;
			//bbsCommand.Parameters.Add(new SqlParameter("@PID", SqlDbType.Int, 4)).Value = oData.PID;
			bbsCommand.Parameters.Add(new SqlParameter("@TABLEID", SqlDbType.Int, 4)).Value = intTableID;
			bbsCommand.Parameters.Add(new SqlParameter("@SUBJECT", SqlDbType.VarChar, 100)).Value = oData.Subject;
			bbsCommand.Parameters.Add(new SqlParameter("@WRITER", SqlDbType.VarChar, 20)).Value = oData.Writer;
			bbsCommand.Parameters.Add(new SqlParameter("@EMAIL", SqlDbType.VarChar, 40)).Value = oData.Email;
			bbsCommand.Parameters.Add(new SqlParameter("@CONTENT", SqlDbType.Text)).Value = oData.Content;
			bbsCommand.Parameters.Add(new SqlParameter("@PASSWORD", SqlDbType.VarChar, 12)).Value = oData.Password;
			bbsCommand.Parameters.Add(new SqlParameter("@USERIP", SqlDbType.VarChar, 20)).Value = oData.UserIP;
			bbsCommand.Parameters.Add(new SqlParameter("@FORMAT", SqlDbType.TinyInt, 1)).Value = oData.Format;

			myConnection.Open();

			bbsTableName.ExecuteNonQuery();
			string strTableName = paraTableName.Value.ToString();
			string sqlInsertFile = "insert into " + strTableName + "Files (bfPID,bfFileName,bfSize,bfContent) ";
			sqlInsertFile += "VALUES (@PID, @FileName, @Size, @Content)";

			SqlCommand bbsFileCommand = new SqlCommand(sqlInsertFile, myConnection);

			SqlTransaction stTrans = myConnection.BeginTransaction();
			//Ʈ
			bbsCommand.Transaction = stTrans;
			bbsFileCommand.Transaction = stTrans;

			try
			{
				bbsCommand.ExecuteNonQuery();

				for ( int intFileIndex = 0; intFileIndex < UploadFiles.Count; intFileIndex++ ) 
				{
					HttpPostedFile _postedFile = UploadFiles[intFileIndex]; 
					String strFileName = Path.GetFileName(_postedFile.FileName);

					if (strFileName == "") continue;

					int intSize = _postedFile.ContentLength;
					System.Byte[] FileByteArray = new System.Byte[intSize];
					Stream StreamObj = _postedFile.InputStream;
					StreamObj.Read(FileByteArray,0,intSize);

					bbsFileCommand.Parameters.Clear();
					bbsFileCommand.Parameters.Add(new SqlParameter("@PID", SqlDbType.Int, 4)).Value = Convert.ToInt32(bbsCommand.Parameters["RETURN_VALUE"].Value);
					bbsFileCommand.Parameters.Add(new SqlParameter("@FileName", SqlDbType.Char, 30)).Value = strFileName;
					bbsFileCommand.Parameters.Add(new SqlParameter("@Size", SqlDbType.BigInt)).Value = intSize;
					bbsFileCommand.Parameters.Add(new SqlParameter("@Content", SqlDbType.Image)).Value = FileByteArray;

					bbsFileCommand.ExecuteNonQuery();
				}
				stTrans.Commit();
			}
			catch(Exception e) 
			{
				string s = e.Message;
				stTrans.Rollback();
			}
			finally
			{
				myConnection.Close();
			}
		}

		public int GetTotalCount(int intTableID)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("SP_GET_TOTAL_COUNT", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add("RETURN_VALUE", SqlDbType.Int).Direction = ParameterDirection.ReturnValue;
			myCommand.Parameters.Add(new SqlParameter("@TABLEID", SqlDbType.Int, 4)).Value = intTableID;

			myConnection.Open();
			myCommand.ExecuteNonQuery();
			myConnection.Close();

			return Convert.ToInt32(myCommand.Parameters["RETURN_VALUE"].Value);
		}

		public void IncVisted(int intPID, int intTableID)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("SP_INCREASE_VISTED", myConnection);

			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@PID", SqlDbType.Int, 4)).Value = intPID;
			myCommand.Parameters.Add(new SqlParameter("@TABLEID", SqlDbType.Int, 4)).Value = intTableID;

			myConnection.Open();
			myCommand.ExecuteNonQuery();
			myConnection.Close();
		}
	}
}
