namespace PowerOfDotNet.MyPage
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Collections;
	using MyWebLibs.ServerControls;

	public abstract class UserMessageManage : PowerOfDotNet.PortalModuleControl
	{
		protected System.Web.UI.WebControls.TextBox txtReciveUserID;
		protected System.Web.UI.WebControls.DropDownList drpdnlstAddressBook;
		protected System.Web.UI.WebControls.TextBox txtMessage;
		protected MyWebLibs.ServerControls.PagerSkinGrid pgrskngrdMessageList;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator2;
		protected MyWebLibs.ServerControls.MyValidationSummry MyValidationSummry1;
		protected System.Web.UI.WebControls.PlaceHolder placehdrTopPager;
		protected System.Web.UI.WebControls.PlaceHolder placehdrBottomPager;
		protected System.Web.UI.WebControls.Button btnSend;

		private void Page_Load(object sender, System.EventArgs e)
		{

			if (!IsPostBack)
			{
				PowerOfDotNet.Components.WebmailDB db = new PowerOfDotNet.Components.WebmailDB();
				DataSet ds = db.GetUserAddressBook(this.Page.User.Identity.Name, "Name");
				drpdnlstAddressBook.DataSource = ds.Tables[0].DefaultView;
				drpdnlstAddressBook.DataTextField = "Name";
				drpdnlstAddressBook.DataValueField = "FriendUserID";
				drpdnlstAddressBook.DataBind();
				drpdnlstAddressBook.Items.Insert(0, new ListItem("ּҷ", ""));
				drpdnlstAddressBook.Attributes["onchange"] = 
					"document.getElementById('" + 
					txtReciveUserID.ClientID + "').value = " + 
					"document.getElementById('" + 
					drpdnlstAddressBook.ClientID + "').options[" + 
					"document.getElementById('" + 
					drpdnlstAddressBook.ClientID + "').selectedIndex].value";

				BindData();

				txtReciveUserID.Text = MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["to"], "");
			}
			txtReciveUserID.Attributes["onkeypress"] = "if (event.keyCode==13 && Page_ClientValidate()) {" + 
				Page.GetPostBackEventReference(btnSend,"") + ";return false;}";

			placehdrTopPager.Controls.Add(pgrskngrdMessageList.ExportedPager);
			placehdrBottomPager.Controls.Add(pgrskngrdMessageList.ExportedPager);
		}

		public void BindData() 
		{
			ArrayList aDest = new ArrayList();

			string userId = this.Page.User.Identity.Name;
			PowerOfDotNet.Components.MyPageDB db = new PowerOfDotNet.Components.MyPageDB();
			DataSet od = db.GetUserMessageList(userId);

			int intPageSize = pgrskngrdMessageList.PageSize;
			int intCurrentPage = pgrskngrdMessageList.CurrentPageIndex;
			int intTotalCount;

			DataView dataView = od.Tables[0].DefaultView;

			intTotalCount = dataView.Count;

			//޼ Ǹ    ؾѴ.
			while (intPageSize * intCurrentPage >= intTotalCount)
				intCurrentPage--;

			if (intCurrentPage < 0)
				intCurrentPage = 0;

			pgrskngrdMessageList.CurrentPageIndex = intCurrentPage;
			pgrskngrdMessageList.VirtualItemCount = intTotalCount;


			int intStartRow = intCurrentPage * intPageSize;
			int intEndRow = (intStartRow+intPageSize <= intTotalCount) ? intStartRow+intPageSize : intTotalCount;

			for (int intIndex=intStartRow; intIndex < intEndRow; intIndex++)
			{
				PowerOfDotNet.Components.MessageContent mc = new PowerOfDotNet.Components.MessageContent();
			
				mc.ID = (int)dataView[intIndex]["ID"];
				//mc.UserID = dataView[intIndex]["UserID"].ToString();
				mc.SendUserID = dataView[intIndex]["SendUserID"].ToString();
				mc.RecivedDate = (DateTime)dataView[intIndex]["RecivedDate"];
				mc.Message = dataView[intIndex]["Message"].ToString();
				mc.SenderName = dataView[intIndex]["Name"].ToString();
				mc.SenderEmail = dataView[intIndex]["Email"].ToString();
				mc.ReciveUserIDBoxID = txtReciveUserID.ClientID;
				
				aDest.Add(mc);
			}

			pgrskngrdMessageList.DataSource = aDest;
			pgrskngrdMessageList.DataBind();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnSend.Click += new System.EventHandler(this.btnSend_Click);
			this.pgrskngrdMessageList.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.pgrskngrdMessageList_PageIndexChanged);
			this.pgrskngrdMessageList.DeleteCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.pgrskngrdMessageList_DeleteCommand);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnSend_Click(object sender, System.EventArgs e)
		{
			PowerOfDotNet.Components.MyPageDB db = new PowerOfDotNet.Components.MyPageDB();
			int result = db.SendUserMessage(txtReciveUserID.Text, this.Page.User.Identity.Name ,txtMessage.Text);
			if (result == -1)
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack(" ȴ IDԴϴ.");
			
			txtMessage.Text = "";
		}

		private void pgrskngrdMessageList_PageIndexChanged(object source, System.Web.UI.WebControls.DataGridPageChangedEventArgs e)
		{
			((PagerSkinGrid)source).CurrentPageIndex = e.NewPageIndex;
			BindData();
		}

		private void pgrskngrdMessageList_DeleteCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			int id = Int32.Parse(e.CommandArgument.ToString());
			PowerOfDotNet.Components.MyPageDB db = new PowerOfDotNet.Components.MyPageDB();
			db.DeleteMessage(id);
			BindData();
		}
	}
}
