/*
 * 2004 2 20 
 * */

namespace PowerOfDotNet.Shop
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Globalization;

	/// <summary>
	///		ShopProdDetail   Դϴ.
	/// </summary>
	public abstract class ShopProdDetail : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.Image imgProduct;
		protected System.Web.UI.WebControls.Label lblName;
		protected System.Web.UI.WebControls.Label lblAccumulation;
		protected System.Web.UI.WebControls.Label lblBrand;
		protected System.Web.UI.WebControls.Label lblWeight;
		protected System.Web.UI.WebControls.Label lblStone;
		protected System.Web.UI.WebControls.Label lblPrice;
		protected System.Web.UI.WebControls.DropDownList drpdnlstQuantity;
		protected System.Web.UI.WebControls.Repeater reptOptions;
		protected MyWebLibs.ServerControls.PagerSkinGrid pagskngrdReviews;
		protected System.Web.UI.WebControls.HyperLink hyplnkWriteReview;
		protected System.Web.UI.HtmlControls.HtmlTableCell tdReviewPager;
		protected System.Web.UI.WebControls.Label lblDescription;
		protected System.Web.UI.HtmlControls.HtmlInputHidden hiddenNewReview;
		protected System.Web.UI.WebControls.LinkButton lnkbtnWriteReview;
		protected System.Web.UI.WebControls.ImageButton imgbtnAddShoppingCart;

		private int _prodId;

		private void Page_Load(object sender, System.EventArgs e)
		{
			_prodId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["prodId"], -1);
			if (!IsPostBack)
			{
				PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
				SqlDataReader drP = db.GetProduct(_prodId);
				drP.Read();
				lblName.Text = drP["Name"].ToString();
				lblDescription.Text = drP["Description"].ToString();
				lblPrice.Text = drP["Price"].ToString().ToString(new NumberFormatInfo());
				lblWeight.Text = drP["Weight"].ToString();
				lblStone.Text = drP["Stone"].ToString();
				imgProduct.ImageUrl = "~/Shop/Images/Products/" + ShopMethods.GetImageMNameByIDataRecord(drP);
				drP.Close();
/*
0	IndexID	int	4	0
0	Name	nvarchar	40	0
0	Description	ntext	16	0
0	Price	money	8	0
0	DiscountPercent	int	4	0
0	Rcommendation	tinyint	1	0
0	Absence	tinyint	1	0
0	RegDate	smalldatetime	4	0
0	SaleCount	int	4	0
0	BrandID	int	4	1
0	Weight	int	4	1
1	Stone	varchar	50	1
*/
				reptOptions.DataSource = db.GetProductOptList(_prodId);
				reptOptions.DataBind();

				for (int i=1;i<=20;i++)
				{
					drpdnlstQuantity.Items.Add(new ListItem(i + "",i.ToString()));
				}
				drpdnlstQuantity.SelectedIndex = 0;

				ReviewDataBind();

				//hyplnkWriteReview.NavigateUrl = "javascript:OpenReviewWrite('" + 
				//	Server.UrlEncode( lblName.Text ) + "')";

				hyplnkWriteReview.NavigateUrl = "javascript:OpenReviewWrite('" + lblName.Text + "')";

			}

			string scriptAddNewReview = @"
<script language=""javascript"">
<!--
function AddNewReview(newReview)
{{
	document.getElementById('{0}').value = newReview;
	{1};
}}
//-->
</script>
";
			scriptAddNewReview = String.Format(scriptAddNewReview, hiddenNewReview.ClientID, 
				this.Page.GetPostBackEventReference(lnkbtnWriteReview));
			this.Page.RegisterClientScriptBlock("scriptAddNewReview", scriptAddNewReview);

			tdReviewPager.Controls.Add(pagskngrdReviews.ExportedPager);
		}

		private void ReviewDataBind()
		{
			PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
			DataSet ds = db.GetReviewList(_prodId);
			pagskngrdReviews.DataSource = ds.Tables[0].DefaultView;
			pagskngrdReviews.DataBind();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.reptOptions.ItemDataBound += new System.Web.UI.WebControls.RepeaterItemEventHandler(this.reptOptions_ItemDataBound);
			this.pagskngrdReviews.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.pagskngrdReviews_PageIndexChanged);
			this.lnkbtnWriteReview.Click += new System.EventHandler(this.lnkbtnWriteReview_Click);
			this.imgbtnAddShoppingCart.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtnAddShoppingCart_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void reptOptions_ItemDataBound(object sender, System.Web.UI.WebControls.RepeaterItemEventArgs e)
		{
			if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem) 
			{
				int optionId = (int)((IDataRecord)e.Item.DataItem)["OptionId"];
				PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
				
				DropDownList drpdnOptionDefList = (DropDownList)e.Item.FindControl("drpdnOptionDefList");
				drpdnOptionDefList.DataSource = db.GetProductOptionDefList(optionId);
				drpdnOptionDefList.DataTextField = "Text";
				drpdnOptionDefList.DataValueField = "ID";
				drpdnOptionDefList.DataBind();
			}

		}

		private void lnkbtnWriteReview_Click(object sender, System.EventArgs e)
		{
			string newReview = hiddenNewReview.Value;
			PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
			db.AddReview(_prodId, this.Page.User.Identity.Name, 
				Request.Cookies["usersInfo"]["Name"].ToString(), newReview);

			ReviewDataBind();
		}

		private void pagskngrdReviews_PageIndexChanged(object source, System.Web.UI.WebControls.DataGridPageChangedEventArgs e)
		{
			pagskngrdReviews.CurrentPageIndex = e.NewPageIndex;
			ReviewDataBind();
		}

		private void imgbtnAddShoppingCart_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
			string shoppingCartId = db.GetShoppingCartId();
			int cartId = db.AddShoppingCart(shoppingCartId, drpdnlstQuantity.SelectedIndex+1,_prodId);

			foreach (RepeaterItem item in reptOptions.Items)
			{
				DropDownList drpdnOptionDefList = (DropDownList)item.FindControl("drpdnOptionDefList");
				db.AddShoppingCartOption(cartId, Convert.ToInt32(drpdnOptionDefList.SelectedItem.Value));
			}

			Response.Redirect(GetLink("ٱ"));
		}
	}
}