/*
 * 2004 2 20 
 * */

namespace PowerOfDotNet.WebMail
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Collections;

	/// <summary>
	///		AddressBook   Դϴ.
	/// </summary>
	public abstract class AddressBookManage : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.DataGrid datgrdAddressBook;
		protected System.Web.UI.WebControls.TextBox txtName;
		protected System.Web.UI.WebControls.TextBox txtEmail;
		protected System.Web.UI.WebControls.TextBox txtPhone;
		protected System.Web.UI.WebControls.TextBox txtFriendUserID;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstSelectAction;
		protected System.Web.UI.WebControls.TextBox Textbox3;
		protected System.Web.UI.WebControls.TextBox Textbox4;
		//protected System.Web.UI.WebControls.TextBox txtSelName;
		//protected System.Web.UI.WebControls.TextBox txtSelEmail;
		protected System.Web.UI.WebControls.DropDownList drpdnlstSortMethod;
		protected System.Web.UI.WebControls.Button btnAddAddress;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				drpdnlstSortMethod.SelectedIndex = 0;
				BindData();
				txtName.Text = MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["name"], "");
				txtEmail.Text = MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["email"], "").Replace("<","").Replace(">","");
			}
		}

		private void BindData()
		{
			datgrdAddressBook.DataSource = CreateDataSource();
			datgrdAddressBook.DataBind();
		}

		//Ÿҽ 
		private ICollection CreateDataSource()
		{
			DataTable dt = new DataTable();
			DataRow dr;

			dt.Columns.Add(new DataColumn("ID", typeof(Int32)));
			dt.Columns.Add(new DataColumn("Name", typeof(string)));
			dt.Columns.Add(new DataColumn("FriendUserID", typeof(string)));
			dt.Columns.Add(new DataColumn("Email", typeof(string)));
			dt.Columns.Add(new DataColumn("EmailLink", typeof(string)));
			dt.Columns.Add(new DataColumn("Phone", typeof(string)));

			string sortMethod = drpdnlstSortMethod.SelectedItem.Value;
			PowerOfDotNet.Components.WebmailDB db = new PowerOfDotNet.Components.WebmailDB();
			DataSet ds = db.GetUserAddressBook(this.Page.User.Identity.Name, sortMethod);

			DataRowCollection drList = ds.Tables[0].Rows;
			int intTotalCount = drList.Count;
			int intPageSize = datgrdAddressBook.PageSize;
			int intCurrentPage = datgrdAddressBook.CurrentPageIndex;

			// ߻ϸ   ؾѴ.
			while (intPageSize * intCurrentPage >= intTotalCount)
				intCurrentPage--;

			if (intCurrentPage < 0)
				intCurrentPage = 0;

			datgrdAddressBook.CurrentPageIndex = intCurrentPage;
			datgrdAddressBook.VirtualItemCount = intTotalCount;
			
			int intStartRow = intCurrentPage * intPageSize;
			int intEndRow = (intStartRow+intPageSize <= intTotalCount) ? intStartRow+intPageSize : intTotalCount;

			for (int intIndex=intStartRow; intIndex < intEndRow; intIndex++)
			{
				dr = dt.NewRow();

				string email = drList[intIndex]["Email"].ToString();
				dr[0] = drList[intIndex]["ID"].ToString();
				dr[1] = drList[intIndex]["Name"].ToString();
				dr[2] = drList[intIndex]["FriendUserID"].ToString();
				dr[3] = email;
				dr[4] = GetLink("Ͼ") + "&mode=send&to=" + Server.UrlEncode(dr[1].ToString() + " <" + email + ">");
				dr[5] = drList[intIndex]["Phone"].ToString();

				dt.Rows.Add(dr);
			}

			DataView dv = new DataView(dt);
			return dv;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.datgrdAddressBook.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.datgrdAddressBook_PageIndexChanged);
			this.datgrdAddressBook.CancelCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datgrdAddressBook_CancelCommand);
			this.datgrdAddressBook.UpdateCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datgrdAddressBook_UpdateCommand);
			this.datgrdAddressBook.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler(this.datgrdAddressBook_ItemDataBound);
			this.datgrdAddressBook.SelectedIndexChanged += new System.EventHandler(this.datgrdAddressBook_SelectedIndexChanged);
			this.drpdnlstSortMethod.SelectedIndexChanged += new System.EventHandler(this.drpdnlstSortMethod_SelectedIndexChanged);
			this.btnAddAddress.Click += new System.EventHandler(this.btnAddAddress_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void datgrdAddressBook_PageIndexChanged(object source, System.Web.UI.WebControls.DataGridPageChangedEventArgs e)
		{
			((DataGrid)source).CurrentPageIndex = e.NewPageIndex;
			BindData();			
		}

		private void btnAddAddress_Click(object sender, System.EventArgs e)
		{
			PowerOfDotNet.Components.WebmailDB db = new PowerOfDotNet.Components.WebmailDB();
			db.AddAddressBook(this.Page.User.Identity.Name, txtName.Text, txtEmail.Text, txtFriendUserID.Text, txtPhone.Text);
			BindData();
			txtName.Text = String.Empty;
			txtEmail.Text = String.Empty;
			txtFriendUserID.Text = String.Empty;
			txtPhone.Text = String.Empty;
		}

		private void datgrdAddressBook_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (rdobtnlstSelectAction.SelectedIndex == 0)
			{
				((DataGrid)sender).EditItemIndex = ((DataGrid)sender).SelectedIndex;
				BindData();
			}
			else if (rdobtnlstSelectAction.SelectedIndex == 1)
			{
				PowerOfDotNet.Components.WebmailDB db = new PowerOfDotNet.Components.WebmailDB();
				db.DeleteAddressBook(Convert.ToInt32(((DataGrid)sender).Items[((DataGrid)sender).SelectedIndex].Cells[0].Text));
				((DataGrid)sender).SelectedIndex = -1;
				BindData();
			}
		
		}

		private void datgrdAddressBook_ItemDataBound(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.EditItem)
			{
				PowerOfDotNet.Components.WebmailDB db = new PowerOfDotNet.Components.WebmailDB();
				SqlDataReader dr = db.GetOneAddressBook(Convert.ToInt32(e.Item.Cells[0].Text));

				if (dr.Read())
				{
					TextBox txtSelName = (TextBox)e.Item.Cells[2].FindControl("txtSelName");
					txtSelName.Text = dr["Name"].ToString();
					TextBox txtSelEmail = (TextBox)e.Item.Cells[2].FindControl("txtSelEmail");
					txtSelEmail.Text = dr["Email"].ToString();
					TextBox txtSelPhone = (TextBox)e.Item.Cells[2].FindControl("txtSelPhone");
					txtSelPhone.Text = dr["Phone"].ToString();
					TextBox txtSelFriendUserID = (TextBox)e.Item.Cells[2].FindControl("txtSelFriendUserID");
					txtSelFriendUserID.Text = dr["FriendUserID"].ToString();
				}
				dr.Close();
			}
		}

		private void datgrdAddressBook_UpdateCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			int id = Convert.ToInt32(e.Item.Cells[0].Text);

			TextBox txtSelName = (TextBox)e.Item.Cells[2].FindControl("txtSelName");
			TextBox txtSelEmail = (TextBox)e.Item.Cells[2].FindControl("txtSelEmail");
			TextBox txtSelPhone = (TextBox)e.Item.Cells[2].FindControl("txtSelPhone");
			TextBox txtSelFriendUserID = (TextBox)e.Item.Cells[2].FindControl("txtSelFriendUserID");

			PowerOfDotNet.Components.WebmailDB db = new PowerOfDotNet.Components.WebmailDB();
			db.UpdateOneAddressBook(id, txtSelName.Text, txtSelEmail.Text,
									txtSelPhone.Text, txtSelFriendUserID.Text);
			((DataGrid)source).EditItemIndex = -1;
			((DataGrid)source).SelectedIndex = -1;
			BindData();
		}

		private void drpdnlstSortMethod_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			BindData();
		}

		private void datgrdAddressBook_CancelCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			((DataGrid)source).EditItemIndex = -1;
			((DataGrid)source).SelectedIndex = -1;
			BindData();
		}
	}
}
